#include "defextern.h"

#ifndef STRICT
    #define STRICT
#endif
#include <windows.h>
#include <mbstring.h>
#include <fstream.h>
#include <stdlib.h>
#include "jis.h"
#include "initial.h"
#include "file.h"
#include "statusbar.h"
#include "file.h"
#include "easyhtml.h"
#include "buffer.h"

BOOL kaigyo(char c)
{
	return (c==0x0d || c==0x0a);
}

void transRNmail(char *file)
{
	char fnew[MAX_PATH];
	char *buf=szStrRcv;
	int count=0;
	makenewfilename(file,fnew,"$$$");
	ifstream in(file);
	ofstream ou(fnew);
	if(!ou) return;
	while(1)
	{
		in.get(buf[0]);
		if(in.gcount()==0) break;
		if(buf[0]=='\r') count++;
		else ou.put(buf[0]);
		in.get(buf,MAX_RCV,'\r');
		ou.write(buf,in.gcount());
		if(in.eof()) break;
	}
	in.close();
	ou.close();
	remove(file);
	rename(fnew,file);
	setstatus("sϊ", count);
}

char charconv(char c)
{
    //char str[256];

    if (c >= 'A' && c <= 'Z')
        return (c - 'A');
    if (c >= 'a' && c <= 'z')
        return (c - 'a' + 0x1a);
    if (c >= '0' && c <= '9')
        return (c - '0' + 0x34);
    if (c == '+')
        return 0x3e;
    if (c == '/')
        return 0x3f;
    if (c == '=')
        return '\0';
    
    return '\0';
}


// : base64 ܂ŃRs[ÂƂfR[h

void maildecode(char *Str, char *Result)
{
	int i=0;
	while(strstr(&(Str[i]),": base64")!=NULL)
	{
		Result[i]=Str[i];
		i++;
	}
	if(i>0)
	{
		for(int j=0;j<7;j++)
		{
			Result[i]=Str[i];
			i++;
		}
	}
	while(kaigyo(Str[i])) 
	{
		Result[i]=Str[i];
		i++;
	}
	decode(&(Str[i]),&(Result[i]));
}

BOOL decodeskip(char lpszStr)
{
	return(lpszStr==0x0d || lpszStr==0x0a || lpszStr==' ' || lpszStr=='\t');
}

// base64 fR[h

int decode(char *lpszStr, char *lpszResult)
{
    int len, i, iR;
    char a1, a2, a3, a4;

    len = strlen(lpszStr);
    i = 0;
    iR = 0;
    while (1) {
        if (i >= len)
            break;
		while(decodeskip(lpszStr[i])) i++;
        a1 = charconv(lpszStr[i]);
		i++;
		while(decodeskip(lpszStr[i])) i++;
        a2 = charconv(lpszStr[i]);
		i++;
		while(decodeskip(lpszStr[i])) i++;
        a3 = charconv(lpszStr[i]);
		i++;
		while(decodeskip(lpszStr[i])) i++;
        a4 = charconv(lpszStr[i]);
		i++;
        lpszResult[iR] = (a1 << 2) + (a2 >>4);
        lpszResult[iR + 1] = (a2 << 4) + (a3 >>2);
        lpszResult[iR + 2] = (a3 << 6) + a4;
        //i += 4;
        iR += 3;
    }
	lpszResult[iR]=0;
    return iR;
}


int decode(char *lpszStr, char *lpszResult,int &len)
{
	len= decode(lpszStr,lpszResult);
	return len;
}

void MyJisToSJis(char *lpOrg, char *lpDest)
{
    int i = 0, iR = 0, c;
    BOOL bSTART = FALSE;//JIS->SJISϊKvǂ

    while (1) {
        if (lpOrg[i] == 0x1b && lpOrg[i + 1] == 0x24 && (lpOrg[i + 2] == 0x42 || lpOrg[i + 2] == 0x40) ){
            bSTART = TRUE;
            i += 3;
            continue;
        }
        if (lpOrg[i] == 0x1b && lpOrg[i+ 1] == 0x28 && (lpOrg[i + 2] == 0x42 || lpOrg[i + 2] == 0x4a )) {
            bSTART = FALSE;
            i += 3;
            continue;
        }
		// Ƃ肠B< (I$
        if (lpOrg[i] == 0x1b && lpOrg[i+ 1] == 0x28 && lpOrg[i + 2] == 0x49 && lpOrg[i + 3] == '$') {
            bSTART = FALSE;
            i += 4;
			lpDest[iR]=',';
			iR ++;
            continue;
        }
        if (lpOrg[i] >= 0x21 && lpOrg[i] <= 0x7e && bSTART) {
            c = MAKEWORD(lpOrg[i + 1], lpOrg[i]);
            lpDest[iR] = (char)HIBYTE(_mbcjistojms(c));
            lpDest[iR + 1] = (char)LOBYTE(_mbcjistojms(c));
            i += 2;
            iR += 2;
            continue;
        }
        if (i == 0 && lpOrg[0] == '\n') {
            lpDest[iR] = '\r';
            lpDest[iR + 1] = '\n';
            i++;
            iR += 2;
            continue;
        }
        if (lpOrg[i] == '\n' && lpOrg[i - 1] != '\r') {
            lpDest[iR] = '\r';
            lpDest[iR + 1] = '\n';
            i++;
            iR += 2;
            continue;
        }
        if (lpOrg[i] == '\0') {
            lpDest[iR] = lpOrg[i];
            break;
        }
        lpDest[iR] = lpOrg[i];
        iR++;
        i++;
    }
    return;
}


// Content-Transfer-Encoding: quoted-printable
// ̃f[^@ϊ
// 蔲
// ǂݍ݂eLXg[hȂ̂ŉś@0x0a

void fromprintable(char *org, char *result)
{
	int i,r,top;
	i=0;
	r=0;
	top=0;
	BOOL flag=TRUE;//FALSE;

	char buf[3]="00";
	while(org[i]!=0)
	{
		if(org[i]=='=' ) 
		{
			if(strncmp(&(org[i]),"=1B",3)==0 || strncmp(&(org[i]),"=3D",3)==0 || org[i+1]==0x0d || org[i+1]==0x0a)
			{
				flag=TRUE;// '=1B'ŃtOĂ
			}
			if(!flag) 
			{
				result[r]=org[i];
				i++;
				r++;
			}
			else
			{
				i++;
				top++;
				if(org[i]!=0x0d && org[i]!=0x0a)
				{
					strncpy(buf,&(org[i]),2);
					result[r]=strtol(buf,NULL,16);
					i+=2;
					r++;
				}
				else
				{
					while(org[i]==0x0d || org[i]==0x0a) i++;
				}
			}
		}
		else
		{
			result[r]=org[i];
			i++;
			r++;
			top++;
		}
	}
	result[r]=0;
}


void encode(char *lpszOrg, char *lpszDest,BOOL add)
{
    int i = 0, iR = 16;

    if(add) strcpy(lpszDest, "=?ISO-2022-JP?B?");
	else iR=0;

    while (1) {
        if (lpszOrg[i] == '\0') {
            break;
        }
        lpszDest[iR] = convtobase((lpszOrg[i]) >> 2);
        if (lpszOrg[i + 1] == '\0') {
            lpszDest[iR + 1] = convtobase(((lpszOrg[i] & 0x3) << 4) );
            lpszDest[iR + 2] = '=';
            lpszDest[iR + 3] = '=';
            lpszDest[iR + 4] = '\0';
            break;
        }
        lpszDest[iR + 1] = convtobase(((lpszOrg[i] & 0x3) << 4) + ((lpszOrg[i + 1]) >> 4));
        if (lpszOrg[i + 2] == '\0') {
            lpszDest[iR + 2] = convtobase((lpszOrg[i + 1] & 0xf) << 2);
            lpszDest[iR + 3] = '=';
            lpszDest[iR + 4] = '\0';
            break;
        }
        lpszDest[iR + 2] = convtobase(((lpszOrg[i + 1] & 0xf) << 2) + ((lpszOrg[i + 2]) >> 6));
        lpszDest[iR + 3] = convtobase(lpszOrg[i + 2] & 0x3f);
        lpszDest[iR + 4] = '\0';
        i += 3;
        iR += 4;
    }
    if(add) strcat(lpszDest, "?=");
    return;
}


void encodebinary(char *lpszOrg, char *lpszDest,BOOL add,int len)
{
    int i = 0, iR = 16;

    if(add) strcpy(lpszDest, "=?ISO-2022-JP?B?");
	else iR=0;

    while (1) {
        if (i==len) {
            lpszDest[iR ] = '\0';
            break;
        }
        lpszDest[iR] = convtobase(((lpszOrg[i]) >> 2)&0x3f);
        if (i + 1 == len ) {
            lpszDest[iR + 1] = convtobase(((lpszOrg[i] & 0x3) << 4) );
            lpszDest[iR + 2] = '=';
            lpszDest[iR + 3] = '=';
            lpszDest[iR + 4] = '\0';
            break;
        }
        lpszDest[iR + 1] = convtobase(((lpszOrg[i] & 0x3) << 4) + (((lpszOrg[i + 1]) >> 4)&0xf));
        if (i + 2 == len) {
            lpszDest[iR + 2] = convtobase((lpszOrg[i + 1] & 0xf) << 2);
            lpszDest[iR + 3] = '=';
            lpszDest[iR + 4] = '\0';
            break;
        }
        lpszDest[iR + 2] = convtobase(((lpszOrg[i + 1] & 0xf) << 2) + (((lpszOrg[i + 2]) >> 6)&0x3));
        lpszDest[iR + 3] = convtobase(lpszOrg[i + 2] & 0x3f);
        lpszDest[iR + 4] = '\0';
        i += 3;
        iR += 4;
    }
    if(add) strcat(lpszDest, "?=");
    return;
}


void encode64(char *lpszOrg, char *lpszDest,int len)
{
    int i = 0, iR=0;

    while (1) {
        if (i == len) {
            break;
        }
        lpszDest[iR] = convtobase((lpszOrg[i]) >> 2);
        if (i + 1 == len) {
            lpszDest[iR + 1] = convtobase(((lpszOrg[i] & 0x3) << 4) );
            lpszDest[iR + 2] = '=';
            lpszDest[iR + 3] = '=';
            lpszDest[iR + 4] = '\0';
            break;
        }
        lpszDest[iR + 1] = convtobase(((lpszOrg[i] & 0x3) << 4) + ((lpszOrg[i + 1]) >> 4));
        if (i + 2 == len) {
            lpszDest[iR + 2] = convtobase((lpszOrg[i + 1] & 0xf) << 2);
            lpszDest[iR + 3] = '=';
            lpszDest[iR + 4] = '\0';
            break;
        }
        lpszDest[iR + 2] = convtobase(((lpszOrg[i + 1] & 0xf) << 2) + ((lpszOrg[i + 2]) >> 6));
        lpszDest[iR + 3] = convtobase(lpszOrg[i + 2] & 0x3f);
        lpszDest[iR + 4] = '\0';
        i += 3;
        iR += 4;
    }
    return;
}



void MySJisToJis(char *lpszOrg, char *lpszDest)
{
    int i = 0, iR = 0, c;
    BOOL bSTART = FALSE;

    while (1) {
        if (_ismbblead(lpszOrg[i]) && bSTART == FALSE) {
            lpszDest[iR] = 0x1b;
            lpszDest[iR + 1] = 0x24;
            lpszDest[iR + 2] = 0x42;
            c = MAKEWORD(lpszOrg[i + 1], lpszOrg[i]);
            lpszDest[iR + 3] = (char)HIBYTE(_mbcjmstojis(c));
            lpszDest[iR + 4] = (char)LOBYTE(_mbcjmstojis(c));
            bSTART = TRUE;
            i += 2;
            iR += 5;
            if (!_ismbblead(lpszOrg[i])) {
                lpszDest[iR] = 0x1b;
                lpszDest[iR + 1] = 0x28;
                lpszDest[iR + 2] = 0x42;
                bSTART = FALSE;
                iR += 3;
            }
            continue;
        }
        if (_ismbblead(lpszOrg[i]) && bSTART) {
            c = MAKEWORD(lpszOrg[i + 1], lpszOrg[i]);
            lpszDest[iR] = (char)HIBYTE(_mbcjmstojis(c));
            lpszDest[iR + 1] = (char)LOBYTE(_mbcjmstojis(c));
            i += 2;
            iR += 2;
            if (!_ismbblead(lpszOrg[i])) {
                lpszDest[iR] = 0x1b;
                lpszDest[iR + 1] = 0x28;
                lpszDest[iR + 2] = 0x42;
                bSTART = FALSE;
                iR += 3;
            }
            continue;
        }
        if (lpszOrg[i] == '\r') {
            lpszDest[iR] = '\n';
            i += 2;
            iR++;
            continue;
        }
        if (lpszOrg[i] == '\0') {
            lpszDest[iR] = lpszOrg[i];
            break;
        }
        lpszDest[iR] = lpszOrg[i];
        iR++;
        i++;
    }
    return;
}



char convtobase(char ch)
{
	char c=(ch & 0x3f);

    if (c <= 0x19)
        return c + 'A';
    if (c >= 0x1a && c <= 0x33)
        return c - 0x1a + 'a';
    if (c >= 0x34 && c <= 0x3d)
        return c - 0x34 + '0';
    if (c == 0x3e)
        return '+';
    if (c == 0x3f)
        return '/';
    return '=';
}


void convertfileformailtest(char *afile,char *tfile)
{
	int getlen=3*1024;
	ifstream in(afile, ios::binary);
	ofstream ou(tfile, ios::trunc);

	if(in) while(1)
	{
		memset(szStr,0,MAX_EDIT);
		szResult[0]=0;
		in.read(szStr,getlen);
		encode(szStr,szResult,FALSE);
		ou<<szResult<<endl;
		if(in.eof()) break;
	}
}

void convertfileformail(char *afile,char *tfile)
{
	int getlen=3*1024;
	int outstep=76;
	ifstream in(afile, ios::binary);
	ofstream ou(tfile, ios::trunc);
	char *p;

	if(in) while(1)
	{
		memset(szStr,0,MAX_EDIT);
		memset(szResult,0,MAX_EDIT);
		szResult[0]=0;
		in.read(szStr,getlen);
		encodebinary(szStr,szResult,FALSE,in.gcount());
		p=szResult;
		/*
		ou<<szResult<<endl;*/
		while(*p!=0)
		{
			ou.write(p,min(outstep,strlen(p)));
			ou<<endl;
			p+=min(outstep,strlen(p));
		}
		if(in.eof()) break;
	}
}


void decodefilefrommail(char *afile,char *tfile)
{
	int getlen=4*1024;
	ifstream in(afile);//, ios::binary
	ofstream ou(tfile, ios::binary | ios::trunc);

	int len;

	if(in) while(1)
	{
		memset(szStr,0,MAX_EDIT);
		szResult[0]=0;
		in.getline(szStr,getlen);//read
		decode(szStr,szResult,len);
		ou.write(szResult,len);
		if(in.eof()) break;
	}
}


void decodefilefrommail(char *afile)
{
	char tfile[MAX_PATH];
	strcpy(tfile,afile);
	strcat(tfile,"de.txt");
	decodefilefrommail(afile,tfile);
}

char *skipheader(char *str)
{
	char *p;
	char sep[]="\r\n\r\n";
	p=strstr(str,sep);
	if(p==NULL) p=str;
	else p+=strlen(sep);
	return p;
}

BOOL cutbyboundary(char *from, char *to, char *boundary,int num)
{
	*to=0;
	char *p;
	char *startmark =szBuffer;
	strcpy(startmark,"--");
	strcat(startmark,boundary);
	p=from;
	while(num>0)
	{
		p=strstr(from,startmark);
		if(p==NULL) return FALSE;
		p+=strlen(startmark);
		p=skipheader(p);
		from=p;
		num--;
	}
	strcpy(to,p);
	p =strstr(to,szBuffer);
	if(p!=NULL) *p=0;
	return TRUE;
}


void decodemailcontent(char *top, char *str, char *res, char *boundary, int num)
{
	if(strstr(top,": base64")!=NULL)
	{
		maildecode(str, res);
		strcpy(str, res);
	}
	if(strstr(top,": quoted-printable")!=NULL || strstr(top,": Quoted-Printable")!=NULL)
	{
		fromprintable(str, res);
		strcpy(str, res);
	}
	MyJisToSJis(str, res);
	if(strstr(res,"<HTML")!=NULL || strstr(res,"<html")!=NULL || strstr(res,"<body")!=NULL || strstr(res,"<BODY")!=NULL)
	{
		setstatus("html");
		easyhtml(res,str);
		strcpy(res, str);
	}
	else
	{
		setstatus("");
		//strcpy(res, res);
	}
	if(strlen(boundary)>0 && num>=0)// num <0 ̂Ƃ͑S̕\
	{
		strcpy(str,"");
		/*
		while(strlen(str)==0) 
		{
			if(!cutbyboundary(res,str,boundary,num)) break;
		}
		*/
		cutbyboundary(res,str,boundary,num);
		strcpy(res, str);
	}	
}
