#include "defextern.h"

#ifndef STRICT
    #define STRICT
#endif
#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include <iostream.h>
#include <fstream.h>
#include <wininet.h>
#include <windowsx.h>
#include <commctrl.h>
/*
#include "resource.h"
*/
#include "buffer.h"
#include "multimail.h"
#include "file.h"
#include "statusbar.h"


void getdir(char *f)
{
	char *p=strrchr(f,'\\');
	if(p!=NULL) *p=0;
}

BOOL BKsearchDat(ifstream &in,int n)
{
	BOOL f=TRUE;
	while(n+1>0 )
	{
		if(in.eof()) 
		{
			f=FALSE;
			break;
		}
		in.getline(szBuffer,MAX_EDIT,'\n');
		n--;
	}
	return f;
}

BOOL BKsearchPos(ifstream &in,int n)
{
	BOOL f=TRUE;
	while(n-1>0 )
	{
		if(in.eof()) 
		{
			f=FALSE;
			break;
		}
		in.getline(szBuffer,MAX_EDIT, BeckyIdxDataSep );
		n--;
	}
	return f;
}


int hextoi(char *buffer)
{
	int i=0;
	char *ch=buffer;
	if(strlen(ch)<15) while(strlen(ch)>0)
	{
		if(isdigit((int)*ch)) i = i*16 +(*ch-'0');//atoi
		else if(isalpha((int)*ch)) i = i*16 +(tolower(*ch)-'a')+10;
		else 
		{
			i=0;
			break;
		}
		ch++;
	}
	return i;
}


int getedmaxsize(char *file,int num)
{
	int size =0;
	int EDstep=8;
	int EDsizepos=2;
	char *buffer=szBuffer;
	char *p;
	strcpy(buffer,file);
	p=strrchr(buffer,'.');
	if(p==NULL) return 0;

	strcpy(p,".hdx");
	ifstream in(buffer,ios::nocreate);//ios::binary | 
	setstatus(buffer);
	if(in)
	{
		for(int i=0;i<num;i++)
		{
			for(int j=0;j<EDstep;j++)
			{
				in.getline(buffer,MAX_EDIT);
			}
		}
		for(int j=0;j<EDsizepos;j++)
		{
			in.getline(buffer,MAX_EDIT);
		}
		sscanf(buffer,"%d",&size);
		setstatus(size);
	}
	return size;
}

int getbeckysize(char *file,int num)
{
	int size =0;
	int BKsizepos=12;
	char *buffer=szBuffer;
	strcpy(buffer,file);
	getdir(buffer);
	strcat(buffer,"\\Folder.idx");
	ifstream in(buffer,ios::nocreate);//ios::binary | 
	if(in)
	{
		if(BKsearchDat(in,num))
		{
			if(BKsearchPos(in,BKsizepos))
			{
				in.getline(buffer,MAX_PATH, BeckyIdxDataSep );
				setstatus(buffer);
				size =hextoi(buffer);
			}
		}
	}
	return size;
}


BOOL isBeckyFile(char *file)
{
	return (checkExt(file,"bmf") | checkExt(file,"bkl"));
}

BOOL isEdmaxFile(char *file)
{
	return (checkExt(file,"mbx") );
}


_multimail::_multimail()
{
	BeckyIdxDataSep=1;
}

int _multimail::getfilesize(int num)
{
	if(isBeckyFile(file)) return getbeckysize(file,num);
	if(isEdmaxFile(file)) return getedmaxsize(file,num);
	return 0;
}