
#include "defextern.h"

#ifndef STRICT
    #define STRICT
#endif
#include <windows.h>
#include "initial.h"
#include "resource.h"


LRESULT CALLBACK AccSettingProc(HWND hDlg, UINT msg, WPARAM wp, LPARAM lp)
{
    static HWND hName, hServerName, hFrom, hReplyTo, hTo, hUser, hPassword, hPop, hList;
	static mailaccount *acc =getaccount();
	int i;

    switch (msg) {
        case WM_INITDIALOG:
			hList = GetDlgItem(hDlg, IDC_NAMELIST);
            hName = GetDlgItem(hDlg, IDC_EDIT_NAME);
            hServerName = GetDlgItem(hDlg, IDC_EDIT1);
            hFrom = GetDlgItem(hDlg, IDC_EDIT2);
            hReplyTo = GetDlgItem(hDlg, IDC_EDIT3);
            hTo = GetDlgItem(hDlg, IDC_EDIT4);
            hPop = GetDlgItem(hDlg, IDC_POP);
            hUser = GetDlgItem(hDlg, IDC_USER);
            hPassword = GetDlgItem(hDlg, IDC_PASS);
			//getmailaccount(szServerName,szFrom,szReplyTo,szTo);
            SetWindowText(hName, acc->name);
            SetWindowText(hServerName, acc->smtp);
            SetWindowText(hFrom, acc->address);
            SetWindowText(hReplyTo, acc->reply);
            SetWindowText(hTo, acc->to);
            SetWindowText(hPop, acc->pop);
            SetWindowText(hPassword, acc->password);
            SetWindowText(hUser, acc->user);
			setaccountlistbox(hDlg, IDC_NAMELIST);
            SetFocus(hList);
            return TRUE;
        case WM_COMMAND:
            switch (LOWORD(wp)) {
                case IDC_NAMELIST:
					i=SendDlgItemMessage(hDlg,IDC_NAMELIST,LB_GETCURSEL,0,0);
					SendDlgItemMessage(hDlg,IDC_NAMELIST,LB_GETTEXT,i,(LPARAM)(acc->name));
					SetWindowText(hName, acc->name);
                case IDC_LOAD:
                    GetWindowText(hName, acc->name, sizeof(acc->name));
					loadaccount();
					SetWindowText(hName, acc->name);
					SetWindowText(hServerName, acc->smtp);
					SetWindowText(hFrom, acc->address);
					SetWindowText(hReplyTo, acc->reply);
					SetWindowText(hTo, acc->to);
					SetWindowText(hPop, acc->pop);
					SetWindowText(hPassword, acc->password);
					SetWindowText(hUser, acc->user);
					if(HIWORD(wp)==LBN_DBLCLK && LOWORD(wp)==IDC_NAMELIST) 
						EndDialog(hDlg, IDCANCEL);
					break;
                case IDC_SAVE:
                case IDOK:
                    GetWindowText(hName, acc->name, sizeof(acc->name));
                    GetWindowText(hServerName, acc->smtp, sizeof(acc->smtp));
                    GetWindowText(hFrom, acc->address, sizeof(acc->address));
                    GetWindowText(hReplyTo, acc->reply, sizeof(acc->reply));
                    GetWindowText(hTo, acc->to, sizeof(acc->to));
                    GetWindowText(hPop, acc->pop, sizeof(acc->pop));
                    GetWindowText(hUser, acc->user, sizeof(acc->user));
                    GetWindowText(hPassword, acc->password, sizeof(acc->password));
					saveaccount();
                    if (strcmp(acc->reply, "") == 0)
                        strcpy(acc->reply, acc->address);
                    if(LOWORD(wp)==IDOK) EndDialog(hDlg, IDOK);
                    return TRUE;
                case IDCANCEL:
                    EndDialog(hDlg, IDCANCEL);
                    return TRUE;
            }
            return FALSE;
    }
    return FALSE;
}
