
#include "defextern.h"

#ifndef STRICT
    #define STRICT
#endif
#include <windows.h>
#include "initial.h"
#include "filter.h"
#include "resource.h"

LRESULT CALLBACK FilterSettingProc(HWND hDlg, UINT msg, WPARAM wp, LPARAM lp)
{
    static HWND hName, hAction, hValue, hTarget, hList;
	int i;

    switch (msg) {
        case WM_INITDIALOG:
			SetWindowText(hDlg,"tB^[");
			hList = GetDlgItem(hDlg, IDC_NAMELIST);
			hTarget = GetDlgItem(hDlg, IDC_TARGET);
			hValue = GetDlgItem(hDlg, IDC_VALUE);
			hAction = GetDlgItem(hDlg, IDC_ACTION);
			hName = GetDlgItem(hDlg, IDC_NAME);
			//getmailaccount(szServerName,szFrom,szReplyTo,szTo);
            //Edit_SetText(hName, acc->name);
            //Edit_SetText(hServerName, acc->smtp);
			setfilterlistbox(hDlg, IDC_NAMELIST);
            //SetFocus(hList);
            return TRUE;
        case WM_COMMAND:
            switch (LOWORD(wp)) {
                case IDC_NAMELIST:
					i=SendDlgItemMessage(hDlg,IDC_NAMELIST,LB_GETCURSEL,0,0);
					SendDlgItemMessage(hDlg,IDC_NAMELIST,LB_GETTEXT,i,(LPARAM)(filter.name));
					SetWindowText(hName, filter.name);
             //   case IDC_LOAD:
                    //GetWindowText(hName, acc->name, sizeof(acc->name));
					loadfilter();
					SetWindowText(hName, filter.name);
					SetWindowText(hTarget, filter.target);
					SetWindowText(hValue, filter.value);
					SetWindowText(hAction, filter.action);
					if(filter.on) SendDlgItemMessage(hDlg,IDC_FILTER_ON, BM_SETCHECK,1,0);
					else SendDlgItemMessage(hDlg,IDC_FILTER_ON, BM_SETCHECK,0,0);
					if(HIWORD(wp)==LBN_DBLCLK && LOWORD(wp)==IDC_NAMELIST) 
						EndDialog(hDlg, IDCANCEL);
					break;

                case IDC_DEL:
					GetWindowText(hName, filter.name, sizeof(filter.name));
					if(MessageBox(NULL, "̃tB^[폜܂H", filter.name, MB_YESNO)==IDYES)
					{
						delfilter();//filter.name
					}
					SendMessage(hDlg, WM_COMMAND, IDM_RESET_LIST, 0);
				//	SendDlgItemMessage(hDlg,IDM_RESET_LIST,0,0,0);//LB_RESETCONTENT
					break;

                case IDM_RESET_LIST:
					loadfilters();
					SendDlgItemMessage(hDlg,IDC_NAMELIST,LB_RESETCONTENT,0,0);
					setfilterlistbox(hDlg, IDC_NAMELIST);
					break;

                case IDC_SAVE:
                case IDOK:
                    GetWindowText(hName, filter.name, sizeof(filter.name));
                    GetWindowText(hTarget, filter.target, sizeof(filter.target));
                    GetWindowText(hAction, filter.action, sizeof(filter.action));
                    GetWindowText(hValue, filter.value, sizeof(filter.value));
					filter.on=(SendDlgItemMessage(hDlg,IDC_FILTER_ON, BM_GETCHECK,0,0));
					savefilter();
					SendMessage(hDlg, WM_COMMAND, IDM_RESET_LIST, 0);
                    return TRUE;
                case IDCANCEL:
                    EndDialog(hDlg, IDCANCEL);
                    return TRUE;
            }
            return FALSE;
    }
    return FALSE;
}
