
#include "defextern.h"

#ifndef STRICT
    #define STRICT
#endif
//#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <winsock2.h>
#include <iostream.h>
#include <fstream.h>
#include <wininet.h>
#include <windowsx.h>
#include <shellapi.h>
/*
*/
#include <commctrl.h>
#include "resource.h"
#include "main.h"
#include "mail.h"
#include "list.h"
#include "file.h"
#include "initial.h"
#include "addressbook.h"
#include "password.h"
#include "statusbar.h"
#include "mailheader.h"
#include "multimail.h"
#include "wab.h"
#include "strlist.h"
#include "filter.h"
#include "attachfile.h"
#include "jis.h"


#define HEADEND ':'
#define LOG_SHOW_LEN 1000
#define titledef "%s [%s] %s | %s >> %s ,%s"
#define boxtitledef "%s %d/%d"



char cdir[MAX_PATH];
char buffer[MAX_PATH];

char initfile[]="mail.ini";
char logfile[]="maillog.txt";
char sendlogfile[]="sendlog.txt";
char addfile[]="addressbook.txt";
char tempfile[]="mailtemp.s.eml";
char sendext[]="s.eml";
char rcvfile[]="mailrcv.txt";
char ldirfile[]="maildir.txt";
char listfile[]="maillist.ini";
char remotelog[]="remotelog.ini";
char saveboxfile[]="mailSaveBox.dat";
char dustboxfile[]="mailDustBox.dat";
char rcvlogfile[]="rcvlog.txt";

char rcvlogdirfile[MAX_PATH];
char dustboxdirfile[MAX_PATH];
char saveboxdirfile[MAX_PATH];
char initdirfile[MAX_PATH];
char listdirfile[MAX_PATH];
char logdirfile[MAX_PATH];
char sendlogdirfile[MAX_PATH];
char tempdirfile[MAX_PATH];
char localdirfile[MAX_PATH];
char rcvdirfile[MAX_PATH];
char defaultfolder[MAX_PATH];
char editor[MAX_PATH];
char remotelogfile[MAX_PATH];
char remotefrom[MAX_PATH];
char remoteappli[MAX_PATH];
char remotecommand[MAX_PATH];
char commandmail[MAX_PATH];
//char npoptitle[MAX_PATH];
//char npopfolder[MAX_PATH];
char defaultaccount[MAX_PATH];
char mailsavename[MAX_PATH];
char workfile[MAX_PATH];
char initpassword[MAX_INFO];
char tmpdbxfile[]="tmp.eml";
char tmp[MAX_PATH];



const int dbxblocklen=33*16;
int backupfilenow=0;

BOOL skiplock,endpart;
int multifilenow;


#define mailend(buf) (buf[0]=='.' && (buf[1]==0 || buf[1]==0x0d || buf[1]==0x0a))

char ext[10]="g.eml";
char SAVEext[10]="e.eml";
char SENDext[10]="s.eml";

char keywindow[]="setting";
char keybackupfile[]="backup file";
char keymulti[]="multi file";
char keymultititle[]="multi file title";

ofstream lo;
ofstream rcv;
SYSTEMTIME st;
char jikan[16];

//#define MAX_NAME 50
//const int namenummax=50;

//char namelist[namenummax][MAX_NAME];


//int sessionNum;

char linebuffer[getlinemax];

int getnum;
const int GET_MAILLINE =50;
int mailline;
int iminute, iminute_0;

void SendLog::write(char *buf)
{
	if(flag) log<<buf<<endl;
};

void SendLog::open(char *n)
{
	name=n;
	log.open(name,ios::ate | ios::trunc);
};


// ۑؑցiăl[j

void SaveBoxBackUp()
{
	if(!exist(saveboxdirfile)) return;
	char file[MAX_PATH];
	char *p;
	static int num=0;
	strcpy(file,saveboxdirfile);
	p=strrchr(file,'.');
	if(p==NULL) return;

	GetLocalTime(&st);
	while(1)
	{
		wsprintf(p,"%04d%02d%02d_%d.dat",
			st.wYear,st.wMonth,st.wDay,num);
		if(!exist(file)) break;
		num++;
	}
	rename(saveboxdirfile,file);
	AddSaveFile(file);
}


// M[́@㏑Ȃ悤

BOOL isgetmail(char *file)
{
	return (strstr(file,".g.eml")!=NULL);
}


void setfilterkey(char *buffer)
{
	wsprintf(buffer, "FILTER::%s", filter.name);
}


void editbyeditor(char *file)
{
	if(editor[0]!='\"') wsprintf(szStr,"\"%s\"",editor);
	else strcpy(szStr,editor);
	if(file[0]!='\"') wsprintf(szStr0,"\"%s\"",file);
	else strcpy(szStr0,file);
	ShellExecute(NULL, "open",szStr,szStr0, NULL, SW_SHOW);
	setstatus(szStr);
}

void cdiropen()
{
	ShellExecute(NULL, "open","explorer",cdir, NULL, SW_SHOW);
}

void cdiropen(char* name)
{
	char tmp[MAX_PATH];
	if(!multimail) return; 
	char *p;
	strcpy(tmp,name);
	p= strrchr(tmp,'\\');
	if(p!=NULL) *p=0;
	ShellExecute(NULL, "open","explorer",tmp, NULL, SW_SHOW);
}


BOOL istmpmailfile(char *file)
{
	return (strcmp(file,tempfile)==0) ;
}

int getmailline()
{
	return mailline;
}

BOOL dbxskip(ifstream &in,char *content)
{
	char buf[16];
	UINT len;
	BOOL flag=FALSE;
	content[0]=0;
	if(!in.eof()) in.read(buf,4);
	len=(ULONG )buf;
	while(!(buf[0]==0 && buf[1]==0 && buf[2]==0 && buf[3]==0) )
	{
		if(!in.eof()) 
		{
			in.read(content,dbxblocklen-4);
			in.read(buf,4);
		}
	}
	if(!in.eof()) in.read(content,dbxblocklen-16);
	if(!in.eof()) in.read(buf,12);
	return flag;
}

BOOL getdbxdata(ifstream &in,char *content)
{
	char buf[16];
	UINT len;
	BOOL flag=FALSE;
	content[0]=0;
	if(!in.eof()) in.read(buf,4);
	len=(ULONG )buf;
	if(buf[0]==0 && buf[1]==0 && buf[2]==0 && buf[3]==0 )
	{
		in.seekg(-8,ios::cur);
		in.read(buf,4);
		len= (unsigned char)buf[1]*256 + (unsigned char)buf[0];
		in.read(buf,4);
		flag=TRUE;
	}
	else
	{
		len=0x0200;
	}
	if(!in.eof()) 
	{
		in.read(content,dbxblocklen-16);
		content[len]=0;
	}
	if(!in.eof()) in.read(buf,12);
	return flag;
}

void getdbxdata(ifstream &in,char *content,int n)
{
	char buf[16];
	char cont[dbxblocklen];
	int len=0;
	content[0]=0;
	while(len+dbxblocklen-16<n)
	{
		if(in.eof()) break;
		getdbxdata(in,&(content[len]));
		len=len+dbxblocklen-16;
	}
}


BOOL dbxtopcheck(char *content,int i)
{
	/*
	if ((strncmp(content,"Received:",min(i,9))==0) || (strncmp(content,"From ",min(i,5))==0) ) return TRUE;
	else return FALSE;
	*/
	return (strncmp(content,"Received: ",i)==0);
}


void getdbxtop(ifstream &in)
{
	char content[5];
	int i=0;
	while(!in.eof())
	{
		in.read(content,4);
		if(dbxtopcheck(content,4)) break;
		i++;
			/*
		{
			in.read(content,4);
			if(strncmp(content,"ived",4)==0);
			break;
		}
		*/
	}
	in.seekg(-4,ios::cur);
	in.seekg(-4,ios::cur);
	setstatus(i);
}


int getdbxnum(char *f)
{
	char *content=szStr;
	ifstream in(f,ios::nocreate | ios::binary);
	if(!in) return 0;
	
	ULONG ad;
	in.seekg(0x030,ios::beg);
	ad= getaddress(in,4);//index ̈ʒu
	if(ad==0) return FALSE;
	in.seekg(ad,ios::beg);
	ad= 17;//Ⴄ
	in.seekg(ad,ios::cur);
	ad= getaddress(in,3)+1;//[̐
	return ad;

}


// Z^Ao^AhX̐

int getwabnum(char *f)
{
	char *content=szStr;
	ifstream in(f,ios::nocreate | ios::binary);
	if(!in) return 0;
	
	ULONG ad;
	in.seekg(0x014,ios::beg);
	ad= getaddress(in,4);//o^AhX̐
	return ad;

}

int getnpopnum(char *f)
{
	char *content=szStr;
	ifstream in(f,ios::nocreate);
	if(!in) return 0;
	int now=0;
	char *p;

	//[t@C̏ꍇA'.'Gh}[NƂăXLbvB
		while(1)
		{
			if( in.eof() ) break;
			while(1)
			{
				in.getline(content,getlinemax);
				if( mailend(content) )
				{
					now++;
					break;
				}
				if( in.eof() ) break;
			}
		};
	return now;

}

void loadnpopfile(char *f)
{
	if(f[0]==0 && npop.file[0]!=0) strcpy(f,npop.file);
	multimailcheck(f);
	if(dbxmail) npop.npopnum =getdbxnum(f);
	else npop.npopnum =getnpopnum(f);
	npop.skipdatnum =npop.npopnum-1;
}

void setnpopfile(char *f)
{
	strcpy(npop.file,f);
	multimailcheck(f);
	if(wabflag) npop.npopnum =getwabnum(npop.file);
	else if(dbxmail) npop.npopnum =getdbxnum(npop.file);
	else npop.npopnum =getnpopnum(npop.file);
	npop.skipdatnum =npop.npopnum-1;
//	npop.title=npoptitle;
}


// t@Cɕ̃[f[^ꍇ̃XLbv

void skipdatreset()
{
	npop.skipdatnum=0;
}

void skipdatplus()
{
	npop.skipdatnum++;
}

void skipdatplus(int n)
{
	npop.skipdatnum=max(0, npop.skipdatnum +n);
}

void resetgetnum()
{
	getnum=0;
	ofstream ou(listdirfile,ios::trunc);
}


void ResetCurrentDir()
{
	SetCurrentDirectory(cdir);
}

void SendAndLog(SOCKET s,char* buf,int len,int flags)
{
	if(checksocket(s)) send(s, buf, len, flags);
	sendlog.write(buf);
}


void getnumplus()
{
	getnum++;
}

void savegetnum()
{
	char buffer[8];
	wsprintf(buffer,"%d",getnum);
	WritePrivateProfileString(keywindow, "getnumber", buffer, initdirfile);
}

void savegetnum(int num)
{
	getnum=num;
	savegetnum();
}

int getnumfromuid(char *uid)
{
	if(strlen(uid)==0) return -1;
	char buf[8];
	int i;
	for(i=0;i<getnum;i++)
	{
		wsprintf(buf,"%d",i);
		GetPrivateProfileString(buf, "id", "", linebuffer, MAX_PATH, listdirfile);
		if(strcmp(uid,linebuffer)==0) return i;
	}
	return -1;
}


void setmark(int num,char *mark)
{
	char buf[8];
	if(num<0) return;

	wsprintf(buf,"%d",num);
	WritePrivateProfileString(buf, "delete", mark, listdirfile);
}

void setmark(char *uid,char *mark)
{
	if(strlen(uid)==0) return;
	int num;
	num = getnumfromuid(uid);
	setmark(num,mark);
}


void resetmark(char *uid)
{
	if(strlen(uid)==0) return;
	char buf[8];
	int num;
	num = getnumfromuid(uid);
	if(num<0) return;

	wsprintf(buf,"%d",num);
	WritePrivateProfileString(buf, "delete", NOMARK, listdirfile);
}


void ResetHeaderLog()
{
	ofstream ou(rcvlogdirfile,ios::trunc);
}

void SaveHeaderLog(mailheader *mh)
{
	mh->getHeaderInfoLog(szStr);
	ofstream ou(rcvlogdirfile,ios::binary | ios::ate);
	ou<<szStr;
}


BOOL RemoteExist(char* id0)
{
	BOOL flag=FALSE;
	int i=0;
	char buf[8];
	while(1)
	{
		wsprintf(buf,"%d",i+1);
		GetPrivateProfileString(buf, "id", "", linebuffer, MAX_PATH, remotelogfile);
		if(strlen(linebuffer)==0) break;
		if(strcmp(id0,linebuffer)==0) {
			flag=TRUE;
			break;
		}
		i++;

	}
	return flag;
}

int GetNumOfRemoteExeLog()
{
	int i=0;
	char buf[8];
	while(1)
	{
		wsprintf(buf,"%d",i+1);
		GetPrivateProfileString(buf, "id", "", linebuffer, MAX_PATH, remotelogfile);
		if(strlen(linebuffer)==0) break;
		i++;

	}
	return i;
}

void SetRemoteExe(mailheader *mh)
{
	if(RemoteExist(mh->id)) return;
	int num =GetNumOfRemoteExeLog();
	num++;
	char buf[8];
	wsprintf(buf,"%d",num);
	wsprintf(linebuffer,"%s",strstr(mh->subject, remotecomtop)+strlen(remotecomtop));
	TranslateLine(linebuffer);
	WritePrivateProfileString(buf, "id", mh->id, remotelogfile);
	WritePrivateProfileString(buf, "from", mh->from, remotelogfile);
	WritePrivateProfileString(buf, "command", linebuffer, remotelogfile);
	if(strlen(remotefrom)>0 && strcmp(mh->from,remotefrom)!=0) 
	{
		WritePrivateProfileString(buf, "status", "bad address", remotelogfile);

	}
	else
	{
		if(strcmp(linebuffer,"shutdown")==0 || strcmp(linebuffer,"logoff")==0)
		{
			shutdownflag=TRUE;
		}
		else if(strcmp(linebuffer,"exe")==0)
		{
			exeflag=TRUE;
		}
		else
		{
			wsprintf(remotecommand,"%s",linebuffer);
			wsprintf(commandmail,"%s",mailsavename);
			commandflag=TRUE;
		}
	}
}

void savelist(mailheader *mh, int num)
{
	char buf[8];
	wsprintf(buf,"%d",num);
	WritePrivateProfileString(buf, "id", mh->id, listdirfile);
	WritePrivateProfileString(buf, "name", mh->server, listdirfile);
	WritePrivateProfileString(buf, "file", mh->file, listdirfile);
	WritePrivateProfileString(buf, "subject", mh->subject, listdirfile);
	WritePrivateProfileString(buf, "from", mh->from, listdirfile);
	WritePrivateProfileString(buf, "date", mh->date, listdirfile);
	WritePrivateProfileString(buf, "size", mh->size, listdirfile);
	if(mh->rcvend) WritePrivateProfileString(buf, "rcv end", "OK", listdirfile);
	else WritePrivateProfileString(buf, "rcv end", "YET", listdirfile);	

	if(allrcvlog) SaveHeaderLog(mh);
}


// M[񃊃Xgɒǉ@Asŋ؂

void savelist(mailheader *mh)
{
	savelist(mh, getnum);
}

void loadlist(mailheader *mh, int num)
{
	char buf[8];
	mh->reset();
	wsprintf(buf,"%d",num);
	GetPrivateProfileString(buf, "file", "", linebuffer, MAX_PATH, listdirfile);
	if(strlen(linebuffer)>0)
	{
		GetPrivateProfileString(buf, "id", "", mh->id, MAX_PATH, listdirfile);
		GetPrivateProfileString(buf, "name", "", mh->server, MAX_PATH, listdirfile);
		GetPrivateProfileString(buf, "file", "", mh->file, MAX_PATH, listdirfile);
		GetPrivateProfileString(buf, "subject", "", mh->subject, MAX_PATH, listdirfile);
		GetPrivateProfileString(buf, "from", "", mh->from, MAX_PATH, listdirfile);
		GetPrivateProfileString(buf, "date", "", mh->date, MAX_PATH, listdirfile);
		GetPrivateProfileString(buf, "size", "", mh->size, MAX_PATH, listdirfile);
		GetPrivateProfileString(buf, "rcv end", "", buffer, MAX_PATH, listdirfile);
		mh->rcvend =(strcmp(buffer,"OK")==0);
	}
}


void getid(char *file, char *id,char *server,char *mark)
{
	char buf[8];
	int i=0;
	id[0]=0;
	while(1)
	{
		wsprintf(buf,"%d",i);
		GetPrivateProfileString(buf, "file", "", linebuffer, MAX_PATH, listdirfile);
		if(i>getnum && strlen(linebuffer)==0) break;
		if(strcmp(linebuffer,file)==0)
		{
			GetPrivateProfileString(buf, "id", "", id, MAX_PATH, listdirfile);
			GetPrivateProfileString(buf, "name", "", server, MAX_PATH, listdirfile);
			GetPrivateProfileString(buf, "delete", "", mark, MAX_PATH, listdirfile);
			break;
		}
		i++;

	}
}

void loadcontent(char *content)
{
	ifstream in(tempdirfile);
	
	//subject ΂
	in.getline(content,getlinemax);
	if(in.eof())
	{
		content[0]=0;
		return;
	}
	in.read(content,MAX_EDIT);
}

// [Mf[^iwb_tj@Ƃā@{Ƃ肾

void loadcontentfrommail(char *content)
{
	ifstream in(tempdirfile);

	
	//header ΂
	while(1)
	{
		in.getline(content,getlinemax);
		if(in.eof() || content[0]=='\r') break;
	}
	if(in.eof())
	{
		content[0]=0;
		return;
	}
	memset(content,0,MAX_EDIT);
	in.read(content,MAX_EDIT);
}

void settmpname(char *name)
{
	strcpy(tempdirfile,name);
}

void loadtmpheader(mailheader *mh)
{
	readfile(tempdirfile, szStr0);
	mailheaderanalyze(szStr0,mh);
}

void loadtmpmail(char *content)
{
	content[0]=0;
	ifstream in(tempdirfile, ios::binary | ios::nocreate );
	if(!in) return;

	//header ΂
	while(1)
	{
		in.getline(content,getlinemax);
		if(in.eof() || content[0]==HEADEND||content[0]=='\r'||content[0]==0) break;
	}
	if(in.eof())
	{
		return;
	}
	memset(content,0,MAX_EDIT);
	in.read(content,MAX_EDIT);
}



// [Mf[^iwb_tj@Ƃā@擪Ƃ肾

BOOL loadtopfrommail(char *file, char *content)
{
	if(dbxmail)
	{
		return loadtopfromdbxmail(file, content,npop.getskip());
	}
	ifstream in(file,ios::nocreate);
	if(!in) return FALSE;
	int now=0;
	char *p;
	int skip=npop.getskip();

	if(multimail && skip>0) //[t@C̏ꍇA'.'Gh}[NƂăXLbvB
		while(1)
		{
			if(now>=skip || in.eof() ) break;
			while(1)
			{
				if(in.eof()) break;
				in.getline(content,getlinemax);
				if( mailend(content)  )
				{
					now++;
					break;
				}
			}
		};
	if(!in.eof())
	{
		memset(content,0,MAX_EDIT);
		in.read(content,MAX_EDIT-2);
		if(multimail) 
		{
			p=strstr(content+1,"\n.\n");
			if(p!=NULL) *p=0;
		}
	}
	return TRUE;
}
// [Mf[^iwb_tj@Ƃā@擪Ƃ肾, npop file ́@num Ԃ߂̃f[^

BOOL loadtopfrommail(char *file, char *content,int num)
{
	ifstream in(file,ios::nocreate);
	if(!in) return FALSE;
	int now=0;
	char *p;
	num=min(num,npop.getmax());

	//'.'Gh}[NƂăXLbvB
		while(1)
		{
			if(now>=num  ) break;//|| in.eof()
			while(1)
			{
				in.getline(content,getlinemax);
				if( mailend(content)  )
				{
					now++;
					break;
				}
				//if( in.eof() ) break;
			}
		};
	if(!in.eof())
	{
		memset(content,0,MAX_EDIT);
		in.read(content,MAX_EDIT-2);
		if(multimail) 
		{
			p=strstr(content+1,"\n.\n");
			if(p!=NULL) *p=0;
		}
	}
	return TRUE;
}

BOOL dbxmailtop(char *c)
{
	return(strncmp(c,"Received:",9)==0 );//|| strncmp(c,"From ",5)==0
}

BOOL loadtopfromdbxmail(char *file, char *content,int num)
{
	ifstream in(file,ios::binary);
	int now=0;
	char *p;

	ofstream ou(tmp,ios::binary | ios::trunc);
	content[0]=0;
	if( ! dbxsearch(in,num) ) return FALSE;//npop.getskip()+1
	//header ΂
	/*
	*/
	int outlen=0;
	BOOL flag;// mail end flag
	while(!in.eof())
	{
		flag=getdbxdata(in,content);
		ou.write(content,dbxblocklen-16);
		outlen+=(dbxblocklen-16);
		if(outlen>MAX_EDIT ) break;//|| flag
	}
	in.close();
	ou.close();
	dbxmail=FALSE;
	multimail=FALSE;
	readfilebinary(tmp, content);
	multimail=TRUE;
	dbxmail=TRUE;
	return TRUE;
}

// [Mf[^iwb_tj@Ƃā@擪Ƃ肾, npop file ́@num Ԃ߂̃f[^

BOOL loadtopfromdbxmailbinary(char *file, char *content,int num)
{
	ifstream in(file,ios::nocreate | ios::binary);
	if(!in) return FALSE;
	int now=0;
	char *p;
	num=min(num,npop.getmax());
	getdbxtop(in);
	int i=0;
	if(num>0) while(!in.eof())
	{
		getdbxdata(in,content);
		if(dbxmailtop(content)) 
		{
			now++;//蔲
		}
		if(now>=npop.getskip()) 
		{
			break;
		}
	}
	if(!in.eof())
	{
		memset(content,0,MAX_EDIT);
		getdbxdata(in,content,MAX_EDIT-2);
	}
	return TRUE;
}

BOOL loadtopfrommailbinary(char *file, char *content,int num)
{
	if(dbxmail) 
	{
		return loadtopfromdbxmail(file,content,num);
	}
	ifstream in(file,ios::nocreate | ios::binary);
	if(!in) return FALSE;
	int now=0;
	char *p;
	num=min(num,npop.getmax());

	//'.'Gh}[NƂăXLbvB
		while(1)
		{
			if(now>=num || in.eof() ) break;//
			while(1)
			{
				in.getline(content,getlinemax);
				if( mailend(content)  )
				{
					now++;
					break;
				}
				if( in.eof() ) break;//
			}
		};
	if(!in.eof())
	{
		memset(content,0,MAX_EDIT);
		in.read(content,MAX_EDIT-2);
		if(multimail) 
		{
			p=strstr(content+1,"\n.\r");
			if(p!=NULL) 
			{
				p=strstr(p,".");
				*p=0;
			}
		}
	}
	return TRUE;
}

// n byte ,AhXf[^

ULONG getaddress(ifstream &in,int n)
{
	ULONG ans=0;
	unsigned char buf[100];
	in.read(buf,n);
	for(int i=n-1;i>=0;i--)
	{
		ans=ans*256+buf[i];
	}
	return ans;
}
// n byte ,AhXf[^@hex \
/*
ULONG getaddress(ifstream &in,int n, ULONG poshex)
{
	ULONG ans=0;
	int k=0;
	unsigned char buf[100];
	in.read(buf,n);
	for(int i=n-1;i>=0;i--)
	{
		poshex[k]=buf[i]/16;
		poshex[k+1]=buf[;
	}
	return ans;
}*/

// nԖڂ̃[擪T

BOOL dbxsearch(ifstream &in,int n)
{
	ULONG ad;
	in.seekg(0x030,ios::beg);
	ad= getaddress(in,4);//index ̈ʒu
	if(ad==0) return FALSE;
	in.seekg(ad,ios::beg);
	ad= 12+n*12;
	in.seekg(ad,ios::cur);
	ad= getaddress(in,4);//info ̈ʒu
	ad= ad+24+1;
	in.seekg(ad,ios::beg);
	ad= getaddress(in,3);//data ̈ʒu
	in.seekg(ad,ios::beg);
	in.seekg(12,ios::cur);
	return TRUE;
}

BOOL getboxname(char* word,ULONG len)
{
	char *p;
	BOOL f=FALSE;
	int i=0;
	p=word;
	while(i<len)
	{
		p++;
		i++;
		if(strncmp(p,".dbx",4)==0) 
		{
			f=TRUE;
			break;
		}
	}
	if(!f) return FALSE;
	while(*p!=0 && i>0) 
	{
		p--;
		i--;
	}
	strcpy(szResult,p+1);
	strcpy(word,szResult);
	return TRUE;
	/*
	while(p!=0 && i>0) 
	{
		p--;
		i--;
	}*/
}

// nԖڂ̃[box name T

BOOL dbxboxnamesearch(char *f,int n,char *buf)
{
	ULONG ad,adlen;
	ifstream in(f,ios::binary);
	in.seekg(0x030,ios::beg);
	ad= getaddress(in,4);//index ̈ʒu
	if(ad==0) return FALSE;
	in.seekg(ad,ios::beg);
	ad= 12+n*12;
	in.seekg(ad,ios::cur);
	ad= getaddress(in,4);//info ̈ʒu
	in.seekg(ad+4,ios::beg);
	adlen= getaddress(in,4)+4;//info ́ićj
	in.read(buf,adlen);
	
	return getboxname(buf,adlen);
}


// [Mf[^iwb_tj@Ƃā@{Ƃ肾

void loadcontentfromdbxmail(char *file, char *content)
{
	ifstream in(file,ios::binary);
	int now=0;
	char *p;

	content[0]=0;
	ofstream ou(tmp,ios::binary | ios::trunc);

	if( ! dbxsearch(in,npop.getskip()) ) return;
	//header ΂
	/*
	*/
	int outlen=0;
	BOOL flag;// mail end flag
	while(!in.eof())
	{
		flag=getdbxdata(in,content);
		ou.write(content,dbxblocklen-16);
		outlen+=(dbxblocklen-16);
		if(outlen>MAX_EDIT ) break;//|| flag
	}
	in.close();
	ou.close();
	dbxmail=FALSE;
	multimail=FALSE;
	loadcontentfrommail(tmp, content);
	multimail=TRUE;
	dbxmail=TRUE;
}

void loadcontentfrommail(char *file, char *content)
{
	content[0]=0;
	if(dbxmail) 
	{
		loadcontentfromdbxmail(file,content);
		return;
	}
	ifstream in(file);
	int now=0;
	char *p;

	if(multimail && npop.skipdatnum>0) //[t@C̏ꍇA'.'Gh}[NƂăXLbvB
		while(1)
		{
			if(now>=npop.skipdatnum || in.eof() ) break;
			while(1)
			{
				in.getline(content,getlinemax);
				if( mailend(content)  )
				{
					now++;
					break;
				}
				if( in.eof() ) break;
			}
		};
	//npop@header ΂
	//multimailcheck(file);
	if(popmultimail && strstr(file,"SendBox.dat")==NULL) while(!in.eof())
	{
		in.getline(content,getlinemax);
		if( content[0]==HEADEND||content[0]=='\r'|| content[0]=='\0') break;//||content[0]=='\n'
	}
	//header ΂
	while(!in.eof())
	{
		in.getline(content,getlinemax);
		if( content[0]==HEADEND||content[0]=='\r'|| content[0]=='\0') break;//||content[0]=='\n'
	}

	if(in.eof())
	{
		return;
	}
	if(skipsize>0)
	{
		for(int i=0;i<skipsize;i++)
		{
			in.getline(content,getlinemax);
			if(in.eof()) break;
		}
		if(in.eof()) skiplock=TRUE;
	}
	if(!in.eof())
	{
		memset(content,0,MAX_EDIT);
		in.read(content,MAX_EDIT-2);
		if(multimail) 
		{
			p=strstr(content+1,"\n.\n");
			if(p!=NULL) *p=0;
		}
		if(strlen(content)<ENDPART) endpart=TRUE;
		else endpart=FALSE;
	}
}


void skipreset()
{
	skipsize=0;
	skiplock=FALSE;
	endpart=FALSE;
}

void loadfilebinary(char *file,char *buf)
{
	readfilebinary(file,buf);
	if(strlen(buf)<ENDPART) endpart=TRUE;
	else endpart=FALSE;
}

void skipset(long i)
{
	skipsize=0;
	setstatus(skipsize);
}

// ǂݔ΂BsP

void skipplus(long n)
{
	if(skiplock && n>0) return;
	else skiplock=FALSE;
	if(endpart && n>0) n=5;
	skipsize+=n;
	if(skipsize<0) skipsize=0;
	setstatus(skipsize);
}

// t@C̍ŌɃXLbv@ctrl+B

void skipend(char *file)
{
	if(skiplock) return;
	else skiplock=FALSE;
	skipsize=getfilesize(file);
	if(skipsize<0) skipsize=0;
	setstatus(skipsize);
}


void savebinary(char* file,char *data)
{
	ofstream ou(file,ios::binary);
	ou<<data;
}


void getnewfilename(char *file)
{
	GetLocalTime(&st);
	wsprintf(file,"%s\\%04d%02d%02d_%02d%02d%02d.%s",
		cdir,st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond,SENDext);
}


void TranslateWord(char* word)
{
	char buf[MAX_PATH];
	GetPrivateProfileString("dic", word, "", buf, MAX_PATH, initdirfile);
	if(strlen(buf)>0) strcpy(word,buf);
}

// %word% init@C[dic]word=oooo ɂooooɒu
void TranslateLine(char *buf)
{
	char buffer[getlinemax*2];
	strcpy(buffer,buf);
	char* from=buffer;
	char* to=buf;
	int i=0;
	int j=0;
	char temp[getlinemax];
	while(1)
	{
		if(*from==0) break;
		if(*from!='%') 
		{
			*to=*from;
			to++;from++;
		}
		else
		{
			from++;
			strcpy(temp,from);
			char* p=strchr(temp,'%');
			if(p!=NULL) 
			{
				*p=0;
				from+=strlen(temp)+1;
				TranslateWord(temp);
				strcpy(to,temp);//
				to+=strlen(temp);//
			}
			else
			{
				*to='%';
				to++;
			}
		}
	}
	*to=0;
}

//[gA{(content)ɂto,fileZbg
void RemoteFileSendSet(char* file, char *content,mailheader *mh, attach *att)
{
	ifstream in(content);
	if(!in) return;
	while(!in.eof())
	{
		in.getline(linebuffer,getlinemax);
		TranslateLine(linebuffer);
		if(strncmp(linebuffer,"attach ",7)==0 || strncmp(linebuffer,"attach:",7)==0) {att->setfilelist(linebuffer+7);mh->bAttach=TRUE;};
		if(strncmp(linebuffer,"to ",3)==0 || strncmp(linebuffer,"to:",3)==0) wsprintf(mh->to,"%s",linebuffer+3);
		if(strncmp(linebuffer,"file ",5)==0 || strncmp(linebuffer,"file:",5)==0)
		{
			wsprintf(file,"%s",linebuffer+5);
			wsprintf(mh->subject,"%s",linebuffer+5);
		}
		//if() break;
	}

}

// content binary

void savecontent(char *file,char *serv,mailheader *mh,attach *att, char *content)
{
	char endline[]="\r\n";
	if(file!=NULL) 
	{
		if(!checkExt(file,"eml")) return;
		if(isgetmail(file)) return;
	}
	ofstream ou;
	if(file==NULL)
	{
		ou.open(tempdirfile,ios::binary);
	}
	else
	{
		ou.open(file,ios::binary);
	}

	char *pto=mh->to;
	char *pcc=mh->cc;
	char *pbcc=mh->bcc;
	char *server=serv;
	char *sub=mh->subject;
	char *ref=mh->references;
	char *inrep=mh->inreplyto;
	char *p;

	while(1)
	{
		if(*pto==' ') pto++;
		else break;
	}
	while(1)
	{
		if(*pcc==' ') pcc++;
		else break;
	}
	while(1)
	{
		if(*pbcc==' ') pbcc++;
		else break;
	}

	ou.write(tTO,strlen(tTO));
	ou.write(pto,strlen(pto));
	ou<<endline;
	ou.write(tCC,strlen(tCC));
	ou.write(pcc,strlen(pcc));
	ou<<endline;
	ou.write(tBCC,strlen(tBCC));
	ou.write(pbcc,strlen(pbcc));
	ou<<endline;
	ou.write(tACCOUNT,strlen(tACCOUNT));
	ou.write(server,strlen(server));
	ou<<endline;
	if(strlen(ref)>0) 
	{
		ou.write(tREFERENCES,strlen(tREFERENCES));
		ou<<' ';
		ou.write(ref,strlen(ref));
		ou<<endline;
	}
	ou.write(tSUBJECT,strlen(tSUBJECT));
	ou.write(sub,strlen(sub));
	ou<<endline;
	if(att!=NULL)
	{
		att->rewind();
		if(att->num>0) while(1)
		{
			p=att->getnext();
			if(p==NULL) break;
			wsprintf(szResult,"Attach:%s",p );
			ou<<szResult<<endline;
		}
	}

	ou<<':'<<endline;
	ou<<content;
}


void sendcontent(SendLog &sl,char *str)
{
	ifstream in(tempdirfile);

	//header ΂, s؂
	while(1)
	{
		in.getline(str,getlinemax);
		if(in.eof() || str[0]=='\r'|| str[0]==HEADEND || str[0]=='\0') break;
	}
	if(in.eof()) return;
	while(1)
	{
		if(in.eof()) break;
		memset(str,0,sizeof(str));
		in.getline(str,getlinemax);
		sendlog.write(szStr);
	}
}

// ݂̈ʒuŌ܂ňsƂɑM

void sendmaildata(SOCKET &s,ifstream &in,char* str, int linelen)
{
	char buf[getlinemax*2];
	if(linelen==0) linelen=getlinemax;
	else linelen =min(linelen,getlinemax);

	while(1)
	{
		if(in.eof()) break;
		memset(str,0,sizeof(str));
		memset(buf,0,sizeof(buf));
		in.getline(str,linelen);
		MySJisToJis(str,buf);
		strcat(buf, "\r\n");
		SendAndLog(s, buf, strlen(buf), 0);
	}
}

void sendcontent(SOCKET &s,char *str)
{
	ifstream in(tempdirfile);

	//header ΂, s؂
	while(1)
	{
		in.getline(str,getlinemax);
		if(in.eof() || str[0]=='\r'|| str[0]==HEADEND || str[0]=='\0') break;
	}
	if(in.eof()) return;
	sendmaildata(s,in,str,0);
}

void logstart()
{
	char form[]="%04d/%02d/%02d";

	GetLocalTime(&st);
	wsprintf(
		jikan,
		form,
	
		st.wYear,
		st.wMonth,
		st.wDay
	);
	lo<<endl<<jikan<<endl;
}




void initlog()
{
	lo.open(logdirfile,ios::ate | ios::trunc);
	rcv.open(rcvdirfile,ios::ate);
	logstart();
}

// log ̍Ō\

void readlog(char *str,int length)
{
	str[0]=0;
	int getlen=min(length,LOG_SHOW_LEN);
	ifstream in(logdirfile,ios::binary);

	in.seekg(getlen,ios::beg);
	if(!in.eof())
	{
		in.seekg(-getlen,ios::end);
	}
	else
	{
		in.close();
		in.open(logdirfile,ios::binary);
	}
	in.getline(str,getlen,'\n');
	memset(str,0,length);
	if(!in.eof())
	{
		in.read(str,getlen-1);
		str[in.gcount()]=0;
	}
}


void rcvwrite(char *word)
{
	rcv.write(word,strlen(word));
}


// Mf[^Asϊ@\r\n > \n

void transMailLineEnd(char *rec,char *save)
{
	save[0]=0;
	char *p;
	while(1)
	{
		if(strlen(rec)==0) break;
		strcpy(szBuffer0,rec);
		p =strstr(szBuffer0,"\r\n");
		if(p!=NULL) strcpy(p,"\n");
		strcpy(save,szBuffer0);
		rec  +=strlen(szBuffer0);
		save +=strlen(szBuffer0);
		if(p!=NULL)
		{
			rec++;
		}
	}
}

void mailsave(char *word)
{
	setstatus("[mailsave]");
	//setstatus(word);
	ofstream ou(mailsavename,ios::ate);
	transMailLineEnd(word,szBuffer);
	ou.write(szBuffer,strlen(szBuffer));
}

void mailload(char *word)
{
	//setstatus(word);
	ifstream in(mailsavename);
	in.read(word,MAX_EDIT);
}

void log(char *word)
{
	char form[]="%02d:%02d:%02d";

	GetLocalTime(&st);
	wsprintf(
		jikan,
		form,
	
		st.wHour,
		st.wMinute,
		st.wSecond
	);
	lo<<jikan<<" "<<word<<endl;
}

void log(char *co,char* word)
{
	char form[]="%02d:%02d:%02d";

	GetLocalTime(&st);
	wsprintf(
		jikan,
		form,
	
		st.wHour,
		st.wMinute,
		st.wSecond
	);
	lo<<jikan<<" "<<co<<word<<endl;
}

void getdateword(char *s)
{
	wsprintf(
		s,
		"%04d/%02d/%02d",
	
		st.wYear,
		st.wMonth,
		st.wDay
	);
}
void getdateforMsgId(char *s)
{
	GetLocalTime(&st);
	wsprintf(
		s,
		"%04d%02d%02d.%02d%02d%02d",
	
		st.wYear,
		st.wMonth,
		st.wDay,
		st.wHour,
		st.wMinute,
		st.wSecond
	);
}


LONG GetZone()
{
	static TIME_ZONE_INFORMATION tz;
	GetTimeZoneInformation( &tz );
	return tz.Bias;
}

char *GetCommand()
{
	return remotecommand;
}

// ṕ@from𕶎toɒu,̐Ԃ
int ReplaceChr(char* p, char from, char to)
{
	int i=0;
	int len=strlen(p);
	for(int j=0;j<len;j++) if(p[j]==from) {i++;p[j]=to;}
	return i;
}


char* CopyContentBat()
{
	char *content=linebuffer;
	static char bat[]="test.bat";
	ofstream ou(bat,ios::trunc|ios::binary);
	ifstream in(commandmail, ios::binary);
	
	//header ΂
	while(!in.eof())
	{
		in.getline(content,getlinemax);
		if( content[0]=='\r'|| content[0]=='\0') break;//||content[0]=='\n'
	}
	while(!in.eof() && strncmp(linebuffer,"end",3)!=0)
	{
		TranslateLine(linebuffer);
		ou << linebuffer <<endl;//
		in.getline(linebuffer,getlinemax);
	}
	return bat;
}


char* WriteBat()
{
	static char bat[]="test.bat";
	ofstream ou(bat,ios::trunc);
	char* p =remotecommand +strlen(BatTop);
	int i =ReplaceChr(p,',',(char)0)+1;
	for(;i>0;i--)
	{
		TranslateLine(p);
		ou << p << endl;
		p+=strlen(p)+1;
	}

	return bat;
}

char *GetRemoteAppli()
{
	return remoteappli;
}
char* GetZoneWord()
{
	static char wo[6];
	int h,m;
	char p;
	LONG t= -GetZone();
	if(t>=0) 
	{
		p='+';
	}
	else 
	{
		p='-';
		t =-t;
	}
	h=t/60;
	m=t%60;
	wsprintf(wo,"%c%02d%02d",p,h,m);
	return wo;
}
// ݂̔Ni牽Oj

void getthismonth(char *buff,int dis)
{
	int year=st.wYear;
	int month=st.wMonth;
	month+=dis;
	while(month>12 || month<1)
	{
		if(month<1) 
		{
			month+=12;
			year--;
		}
		if(month>12) 
		{
			month-=12;
			year++;
		}
	}

	wsprintf(
		buff,
		"%02d%02d",
	
		year,
		month
	);
}

void gettoday(char *buff)
{
	wsprintf(
		buff,
		"%02d%02d%02d",
	
		st.wYear,
		st.wMonth,
		st.wDay
	);
}

char* getnowtime()
{
	wsprintf(
		linebuffer,
		"%02d:%02d:%02d",
	
		st.wHour,
		st.wMinute,
		st.wSecond
	);
	return linebuffer;
}

char* getnowdatetime()
{
	wsprintf(
		linebuffer,
		"%04d/%02d/%02d %02d:%02d:%02d",
	
		st.wYear,
		st.wMonth,
		st.wDay,

		st.wHour,
		st.wMinute,
		st.wSecond
	);
	return linebuffer;
}

char* getdateformail()
{//Date: Wed, 15 Dec 2004 10:44:48 +0900
	char dd[7][4]={"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};
	char mm[12][4]={"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};
	GetLocalTime(&st);
	wsprintf(
		linebuffer,
		"%3s, %02d %3s %04d %02d:%02d:%02d",
		dd[ st.wDayOfWeek%7 ],
		st.wDay,
		mm[ st.wMonth-1 ],
		st.wYear,

		st.wHour,
		st.wMinute,
		st.wSecond
	);
	return linebuffer;
}

void resetlog()
{
	lo.close();
	lo.open(logdirfile,ios::trunc);
	logstart();
}

void setmailaccount(char* name,char * address, char *reply ,char *to)
{
	strcpy(mymail.smtp, name);
	strcpy(mymail.address, address);
	strcpy(mymail.reply, reply);
	strcpy(mymail.to, to);
}

void getmailaccount(char* name,char * address, char *reply ,char *to)
{
	strcpy(name, mymail.smtp);
	strcpy(address, mymail.address);
	strcpy(reply, mymail.reply);
	strcpy(to, mymail.to);
}

mailaccount *getaccount()
{
	return &mymail;
}

//JgfBNg

void getini_cu()
{
	GetCurrentDirectory(MAX_PATH,cdir);
	wsprintf(initdirfile,"%s\\%s",cdir,initfile);
	wsprintf(saveboxdirfile,"%s\\%s",cdir,saveboxfile);
	wsprintf(dustboxdirfile,"%s\\%s",cdir,dustboxfile);
	wsprintf(rcvlogdirfile,"%s\\%s",cdir,rcvlogfile);
	wsprintf(listdirfile,"%s\\%s",cdir,listfile);
	wsprintf(remotelogfile,"%s\\%s",cdir,remotelog);
	wsprintf(logdirfile,"%s\\%s",cdir,logfile);
	wsprintf(sendlogdirfile,"%s\\%s",cdir,sendlogfile);
	wsprintf(localdirfile,"%s\\%s",cdir,ldirfile);
	wsprintf(tempdirfile,"%s\\%s",cdir,tempfile);
	wsprintf(rcvdirfile,"%s\\%s",cdir,rcvfile);
	wsprintf(adddirfile,"%s\\%s",cdir,addfile);
	wsprintf(tmp,"%s\\%s",cdir,tmpdbxfile);
}

void setmailsavename(char *file)
{
	wsprintf(mailsavename,"%s\\%s.%s",cdir,file,ext);
}

void mailsavefileinit()
{
	ofstream ou(mailsavename,ios::trunc);
}

char* getmailsavename()
{
	char *f=strrchr(mailsavename,'\\');
	if(f!=NULL) f++;
	else f=mailsavename;
	return f;
}

void setmailsavename(int n)
{
	wsprintf(mailsavename,"%s\\mail%06d.%s",cdir,n,ext);
}

void setmailsavename()
{
	getnum++;
	wsprintf(mailsavename,"%s\\%04d%02d%02d_%02d%02d%02d_%03d.%s",
		cdir,st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond,getnum,ext);
}

void setmailsavename(mailheader *mh)
{
	char su[17],fr[17];
	strncpy(su,mh->subject,16);
	strncpy(fr,mh->from,16);
	wsprintf(mailsavename,"%s\\%s-%s.%s",cdir,su,mh->date,ext);
}

// npop `ŕ[t@Cɒǉ
// [npop header] + [mail] + '.'

void AddEmlToBox(char *file,char *pop, char *box)
{
	ofstream ou(box,ios::ate);
	ou.seekp(0,ios::end);
	ifstream in(file);
	ou<<"X-Account: "<<pop<<endl;
	ou<<"Content-Length: "<<getfilesize(file)<<endl;
	while(!in.eof())
	{
		in.read(szBuffer,MAX_EDIT);
		ou.write(szBuffer,in.gcount());
	}
	ou<<endl<<'.'<<endl;
}

// npop `ŕ[t@Cɒǉ
// [npop header] + [mail] + '.'

void AddEmlToBox(char *file,char *box)
{
	ofstream ou(box,ios::ate);
	ou.seekp(0,ios::end);
	ifstream in(file);
	while(!in.eof())
	{
		in.read(szBuffer,MAX_EDIT);
		ou.write(szBuffer,in.gcount());
	}
	ou<<endl<<'.'<<endl;
}

// Ƃ̃t@C͋t@Cɂi폜}[N悤ɁAt@Ccj

void saveeml(char *filename, char *pop)
{
	AddEmlToBox(filename,pop,saveboxdirfile);
	char *p;
	ofstream ou;
	ou.open(filename);
}

void deletealldust()
{
	ofstream ou(dustboxdirfile,ios::trunc);
}


BOOL dustfile(char *file)
{
	AddEmlToBox(file,dustboxdirfile);
	remove(file);
	return TRUE;
}


// tđMς݃[l[

void renamesent(char *file,char *newname)
{
	ifstream in(file);
	ofstream ou(newname);
	char buffer;
	if(!in || !ou) return;
	ou<<"Date: "<<getnowdatetime()<<endl;
	while(1)
	{
		in.get(buffer);
		if(in.gcount()==0) break;
		ou.put(buffer);
	}
	in.close();
	remove(file);
}

void savesenteml(char *file)
{
	char *p;
	strcpy(szStr,file);
	p =strrchr(szStr,'s');
	if(p!=NULL)
	{
		*p='z';
		renamesent(file,szStr);
	}
}

char *getdeffaoutaccount()
{
	return defaultaccount;
}

void loadfilter()
{
	setfilterkey(buffer);
	GetPrivateProfileString(buffer, "target", "", filter.target, MAX_PATH, initdirfile);
	GetPrivateProfileString(buffer, "value", "", filter.value, MAX_PATH, initdirfile);
	GetPrivateProfileString(buffer, "action", "", filter.action, MAX_PATH, initdirfile);
	GetPrivateProfileString(buffer, "on", "", buffer, MAX_PATH, initdirfile);
	filter.on=(strcmp(buffer,"on")==0);
}

void loadaccount()
{
	GetPrivateProfileString(mymail.name, "smtp", "", mymail.smtp, MAX_PATH, initdirfile);
	GetPrivateProfileString(mymail.name, "address", "", mymail.address, MAX_PATH, initdirfile);
	GetPrivateProfileString(mymail.name, "reply", "", mymail.reply, MAX_PATH, initdirfile);
	//GetPrivateProfileString(mymail.name, "to", "", mymail.to, MAX_PATH, initdirfile);
	GetPrivateProfileString(mymail.name, "pop", "", mymail.pop, MAX_PATH, initdirfile);
	GetPrivateProfileString(mymail.name, "user", "", mymail.user, MAX_PATH, initdirfile);
	GetPrivateProfileString(mymail.name, "smtp auth type", "DIGEST-MD5", mymail.SmtpAuthType, MAX_PATH, initdirfile);
	if(strlen(defaultfolder)==0)
		GetPrivateProfileString(mymail.name, "folder", "", mymail.folder, MAX_PATH, initdirfile);

	GetPrivateProfileString(mymail.name, "password", "", mymail.passhide, MAX_PATH, initdirfile);
	pickpassword();
	GetPrivateProfileString(mymail.name, "apop", "off", buffer, MAX_PATH, initdirfile);
	if(strcmp(buffer,"off")==0) mymail.apopmode=FALSE;
	else mymail.apopmode=TRUE;
	GetPrivateProfileString(mymail.name, "apop retry", "off", buffer, MAX_PATH, initdirfile);
	if(strcmp(buffer,"off")==0) mymail.apopretry=FALSE;
	else mymail.apopretry=TRUE;
	GetPrivateProfileString(mymail.name, "pop before smtp", "off", buffer, MAX_PATH, initdirfile);
	if(strcmp(buffer,"off")==0) mymail.PopBeforeSmtp=FALSE;
	else mymail.PopBeforeSmtp=TRUE;
	GetPrivateProfileString(mymail.name, "smtp auth", "off", buffer, MAX_PATH, initdirfile);
	if(strcmp(buffer,"off")==0) mymail.SmtpAuth=FALSE;
	else mymail.SmtpAuth=TRUE;
	GetPrivateProfileString(mymail.name, "sync", "on", buffer, MAX_PATH, initdirfile);
	if(strcmp(buffer,"on")==0 || strcmp(buffer,"ON")==0) mymail.sync=TRUE;
	else mymail.sync=FALSE;
	title();
}

void loadaccount(char *str)
{
	strncpy(mymail.name, str, sizeof(mymail.name));
	loadaccount();
}

int gettimerminute()
{
	if(iminute<1) iminute=1;
	return iminute;
}

void resettimerminute()
{
	iminute = iminute_0;
}

void settimerminute(int i)
{
	iminute = i;
}


void timeron(BOOL f)
{
	timerflag=f;
	firsttimerflag=f;
}


int GetSaveFileNum()
{
	char buf[5],file[MAX_PATH];
	int num=1;
	while(1)
	{
		wsprintf(buf,"%d",num);
		GetPrivateProfileString(keybackupfile, buf, "", file, MAX_PATH, initdirfile);
		if(strlen(file)==0) 
		{
			num--;
			break;
		}
		num++;
	}
	return num;
}


void AddSaveFile(char *file)
{
	if(strlen(file)==0) return;

	int num =GetSaveFileNum() +1;
	char buf[5];
	wsprintf(buf,"%d",num);
	WritePrivateProfileString(keybackupfile, buf, file, initdirfile);
}

void GetNextSaveFile(char *file)
{
	char buf[5];
	backupfilenow--;
	if(backupfilenow<0) backupfilenow =GetSaveFileNum();
	wsprintf(buf,"%d",backupfilenow);
	GetPrivateProfileString(keybackupfile, buf, "", file, MAX_PATH, initdirfile);
	if(strlen(file)==0) 
	{
		backupfilenow=0;
	}
	if(backupfilenow==0) strcpy(file,saveboxdirfile);
}

char* GetRemoteFrom()
{
	return remotefrom;
}

void init()
{
	char newword[100];
	int kb;
	getini_cu();
	initlog();
	sendlog.open(sendlogdirfile);
	sendlog.off();
	sendlogonlyflag=FALSE;
	boxmax=BOX_MAX;
	npopshowmax=NPOPSHOWMAX;
	multifilenow=1;
	shutdownflag=FALSE;
	exeflag=FALSE;
	commandflag=FALSE;

	mywin.x = GetPrivateProfileInt(keywindow, "x",0,initdirfile);
	mywin.y = GetPrivateProfileInt(keywindow, "y",0,initdirfile);
	mywin.wx = GetPrivateProfileInt(keywindow, "wx",0,initdirfile);
	mywin.wy = GetPrivateProfileInt(keywindow, "wy",0,initdirfile);
	mywin.mode = GetPrivateProfileInt(keywindow, "mode",BOTHU_SHOW,initdirfile);

	getnum = GetPrivateProfileInt(keywindow, "getnumber",0,initdirfile);
	mailline = GetPrivateProfileInt(keywindow, "getline",GET_MAILLINE,initdirfile);
	iminute_0 = iminute = GetPrivateProfileInt(keywindow, "timer",20,initdirfile);
	//IntervalOnRemote = GetPrivateProfileInt(keywindow, "remote timer",1,initdirfile);

	kb = GetPrivateProfileInt(keywindow, "get KB",6,initdirfile);
	mailgetsize=kb*1024;

	GetPrivateProfileString(keywindow, "password", "", initpassword, MAX_INFO, initdirfile);
	GetPrivateProfileString(keywindow, "folder", "", defaultfolder, MAX_PATH, initdirfile);
	GetPrivateProfileString(keywindow, "default account", "", defaultaccount, MAX_PATH, initdirfile);
	GetPrivateProfileString(keywindow, "name", "", mymail.name, MAX_PATH, initdirfile);
	GetPrivateProfileString(keywindow, "title", titledef, titles, MAX_PATH, initdirfile);
	GetPrivateProfileString(keywindow, "boxtitle", boxtitledef, boxtitleform, MAX_PATH, initdirfile);
	GetPrivateProfileString(keywindow, "timer?", "on", newword, MAX_PATH, initdirfile);
	if(strcmp(newword,"on")==0) 
	{
		timeron(TRUE);
	}
	else timeron(FALSE);
	GetPrivateProfileString(keywindow, "hide?", "off", newword, MAX_PATH, initdirfile);
	if(strcmp(newword,"off")==0) hidemeflag=FALSE;
	else hidemeflag=TRUE;
	GetPrivateProfileString(keywindow, "return mark", "Re:", returnmark, MAX_PATH, initdirfile);
	if(strlen(returnmark)==0) strcpy(returnmark, "Re:");
	
	
	GetPrivateProfileString(keywindow, "remote from", "", remotefrom, MAX_PATH, initdirfile);
	GetPrivateProfileString(keywindow, "remote appli", "", remoteappli, MAX_PATH, initdirfile);
	GetPrivateProfileString(keywindow, "remote exe", "off", newword, MAX_PATH, initdirfile);
	RemoteExeMode=(strcmp(newword,"on")==0);
	GetPrivateProfileString(keywindow, "copy on reply", "off", newword, MAX_PATH, initdirfile);
	CopyOnReply=(strcmp(newword,"on")==0);
	GetPrivateProfileString(keywindow, "rcv copy", "off", newword, MAX_PATH, initdirfile);
	rcvcopy=(strcmp(newword,"on")==0);
	GetPrivateProfileString(keywindow, "all rcv log", "off", newword, MAX_PATH, initdirfile);
	allrcvlog=(strcmp(newword,"on")==0);
	GetPrivateProfileString(keywindow, "hide subject", "off", newword, MAX_PATH, initdirfile);
	HideSubject=(strcmp(newword,"on")==0);
	GetPrivateProfileString(keywindow, "reply head", "> ", newword, MAX_PATH, initdirfile);
	GetPrivateProfileString(keywindow, "editor", "notepad", editor, MAX_PATH, initdirfile);
	strncpy(replyheadmark, newword, 30);
	getmultifilename(multifilenow);
	if(npop.file[0]!=0) boxmax=NPOP_BOX;
	loadaccount();
	loadsession();
	loadfilters();

	return;
}

void multifilenumplus(int n)
{
	multifilenow++;
	getmultifilename(multifilenow);
	getmultifiletitle(n,NULL);
	if(npop.file[0]==0) multifilenow=0;
}

void getmultifilename(int n)
{
	char buf[5];
	wsprintf(buf,"%d",n);
	GetPrivateProfileString(keymulti, buf, "", npop.file, MAX_PATH, initdirfile);
}

void getmultifiletitle(int n,char *title)
{
	char buf[5];
	wsprintf(buf,"%d",n);
	GetPrivateProfileString(keymultititle, buf, "", npop.title, MAX_PATH, initdirfile);
	if(title!=NULL) strcpy(title, npop.title);
}

BOOL getmultiname(char *f,int n)
{
	getmultifilename(n);
	getmultifiletitle(n,NULL);
	if(npop.file[0]==0) return FALSE;
	f[0]=0;
	loadnpopfile(f);
	return TRUE;
}

void WritePrivateProfileBOOL(char *name, char *key, BOOL value, char *file)
{
	char word[4];
	if(value==TRUE) strcpy(word,"on");
	else strcpy(word,"off");

	WritePrivateProfileString(name, key, word, file);
}


void saveaccount()
{
	if(strlen(mymail.name)==0) return;
	WritePrivateProfileString(mymail.name, "smtp", mymail.smtp, initdirfile);
	WritePrivateProfileString(mymail.name, "address", mymail.address, initdirfile);
	WritePrivateProfileString(mymail.name, "reply", mymail.reply, initdirfile);
	WritePrivateProfileString(mymail.name, "to", mymail.to, initdirfile);
	WritePrivateProfileString(mymail.name, "pop", mymail.pop, initdirfile);
	WritePrivateProfileString(mymail.name, "user", mymail.user, initdirfile);
	WritePrivateProfileString(mymail.name, "folder", mymail.folder, initdirfile);
	WritePrivateProfileBOOL(mymail.name, "sync", mymail.sync, initdirfile);

	hidepassword();
	WritePrivateProfileString(mymail.name, "password", mymail.passhide, initdirfile);
	savesession(mymail.name);
}


void savefilter()
{
	if(strlen(filter.name)==0) return;
	setfilterkey(buffer);
	WritePrivateProfileString(buffer, "action", filter.action, initdirfile);
	WritePrivateProfileString(buffer, "target", filter.target, initdirfile);
	WritePrivateProfileString(buffer, "value", filter.value, initdirfile);
	if(filter.on) WritePrivateProfileString(buffer, "on", "on", initdirfile);
	else WritePrivateProfileString(buffer, "on", "off", initdirfile);
	savefiltername(filter.name);
}

void delfilter()
{
	if(strlen(filter.name)==0) return;
	wsprintf(buffer, "FILTER::", filter.name);
	WritePrivateProfileString(buffer, NULL, NULL, initdirfile);
	delfiltername(filter.name);
}

int initcolumnsize(int n)
{
	char name[30];

	wsprintf(name,"column%d",n);
	return GetPrivateProfileInt(keywindow, name, 0, initdirfile);
}

void saveinitcolumnsize(int n, int size)
{
	char name[30];
	char buffer[MAX_INFO];
	//itoa()
	wsprintf(name,"column%d",n);
	wsprintf(buffer,"%d",size);
	WritePrivateProfileString(keywindow, name, buffer, initdirfile);
}

void saveinit()
{
	char buffer[MAX_INFO];
	//itoa()
	SaveColumnSize(); 
	wsprintf(buffer,"%d",mywin.x);
	WritePrivateProfileString(keywindow, "x", buffer, initdirfile);
	wsprintf(buffer,"%d",mywin.y);
	WritePrivateProfileString(keywindow, "y", buffer, initdirfile);
	wsprintf(buffer,"%d",mywin.wx);
	WritePrivateProfileString(keywindow, "wx", buffer, initdirfile);
	wsprintf(buffer,"%d",mywin.wy);
	WritePrivateProfileString(keywindow, "wy", buffer, initdirfile);
	wsprintf(buffer,"%d",mywin.mode);
	WritePrivateProfileString(keywindow, "mode", buffer, initdirfile);

	wsprintf(buffer,"%d",mailline);
	WritePrivateProfileString(keywindow, "getline", buffer, initdirfile);
	wsprintf(buffer,"%d",iminute);
	WritePrivateProfileString(keywindow, "timer", buffer, initdirfile);

	WritePrivateProfileString(keywindow, "name", mymail.name, initdirfile);
	WritePrivateProfileString(keywindow, "password", initpassword, initdirfile);

	
	return;
}

void savesession(char *name,int num)
{
	char buf[30];
	wsprintf(buf,"%d",num);
	WritePrivateProfileString(keysession, buf, name, initdirfile);
}


BOOL exist(strlist &li,char *key,char *name, int *num)
{
	char name0[MAX_PATH];
	char buf[30];
	for(int i=0; i<=li.max && i<strmaxnum ; i++)
	{
		wsprintf(buf,"%d",i);
		GetPrivateProfileString(key, buf, "", name0, MAX_PATH, initdirfile);
		if(num!=NULL) *num=i;
		if(strcmp(name,name0)==0) return TRUE;
	}
	return FALSE;
}


void savesession(char *name)
{
	if(exist(acclist,keysession,name,NULL)) return;
	acclist.max++;
	char buf[30];
	wsprintf(buf,"%d",acclist.max);
	WritePrivateProfileString(keysession, buf, name, initdirfile);
}

void savefiltername(char *name)
{
	if(exist(filterlist,keyfilter,name,NULL)) return;
	filterlist.max++;
	char buf[30];
	wsprintf(buf,"%d",filterlist.max);
	WritePrivateProfileString(keyfilter, buf, name, initdirfile);
}


void delfiltername(char *name)
{
	int num;
	if(exist(filterlist,keyfilter,name,&num)) 
	{
		char buf[30];/*
		wsprintf(buf,"%d",num);
		WritePrivateProfileString(keyfilter, buf, NULL, initdirfile);*/
		if(num<filterlist.max)
		{
			for(int i=num;i<filterlist.max;i++)
			{
				wsprintf(buf,"%d",i+1);
				GetPrivateProfileString(keyfilter, buf, "", filter.name, MAX_PATH, initdirfile);
				wsprintf(buf,"%d",i);
				WritePrivateProfileString(keyfilter, buf, filter.name, initdirfile);
			}
			wsprintf(buf,"%d",filterlist.max);
			WritePrivateProfileString(keyfilter, buf, NULL, initdirfile);
		}
		filterlist.max--;
	}
}


BOOL setaccount(int num)
{
	if(num>acclist.max || num<1 ) return FALSE;
	mymail.setname(acclist.value[num-1]);
	loadaccount();
	return TRUE;
}


void loadsession()
{
	char buf[30];
	acclist.max=0;
	for(int i=0; i<strmaxnum ; i++)
	{
		wsprintf(buf,"%d",i+1);
		GetPrivateProfileString(keysession, buf, "", acclist.value[i], MAX_PATH, initdirfile);
		if(strlen(acclist.value[i])==0) break;
		acclist.max = i+1;
		AppendMenu(hSessionMenu,MF_STRING,sessionIDBASE+i,acclist.value[i]);
	}
}

void loadfilter(int num)
{
	if(num<1) return;
	char buf[30];
	wsprintf(buf,"%d",num);
	GetPrivateProfileString(keyfilter, buf, "", filterlist.value[num-1], MAX_PATH, initdirfile);
	strcpy(filter.name,filterlist.value[num-1]);
	loadfilter();
}

void loadfilters()
{
	filterlist.reset();
	for(int i=1; i<strmaxnum ; i++)
	{
		loadfilter(i);
		if(strlen(filterlist.value[i-1])==0) break;
		filterlist.max = i;
		//AppendMenu(hSessionMenu,MF_STRING,sessionIDBASE+i,acclist.value[i]);
	}
}

void setaccountlistbox(HWND &hdlg,UINT IDC)
{
	for(int i=0; i<acclist.max && i<strmaxnum ; i++)
	{
		SendDlgItemMessage(hdlg,IDC,LB_ADDSTRING,0,(LPARAM)acclist.value[i]);
	}
}

void setfilterlistbox(HWND &hdlg,UINT IDC)
{
	for(int i=0; i<filterlist.max && i<strmaxnum ; i++)
	{
		SendDlgItemMessage(hdlg,IDC,LB_ADDSTRING,0,(LPARAM)filterlist.value[i]);
	}
}



char *gettmpfile(char *f)
{
	wsprintf(workfile,"%s\\%s",cdir,f);
	return workfile;
}



LRESULT CALLBACK SettingProc(HWND hDlg, UINT msg, WPARAM wp, LPARAM lp)
{
    static HWND hTimer,hPass;
	char buffer[MAX_PATH];

    switch (msg) {
        case WM_INITDIALOG:
			hTimer = GetDlgItem(hDlg, IDC_EDIT_TIMER);
			hPass = GetDlgItem(hDlg, IDC_EDIT_PASSWORD);
			wsprintf(buffer,"%d",iminute);
			SetWindowText(hDlg,"ݒ");
			SetWindowText(hTimer,buffer);
			SetWindowText(hPass,initpassword);
            SetFocus(hTimer);
            return TRUE;
        case WM_COMMAND:
            switch (LOWORD(wp)) {
                case IDOK:
                    Edit_GetText(hTimer, buffer, MAX_PATH);
                    Edit_GetText(hPass, initpassword, MAX_INFO);
					sscanf(buffer,"%d",&iminute);
                case IDCANCEL:
                    EndDialog(hDlg, IDCANCEL);
                    return TRUE;
            }
            return FALSE;
    }
    return FALSE;
}


BOOL initpasswordcheck()
{
	BOOL ans=FALSE;
	if(initpassword[0]==0) ;
	else ans=TRUE;
	return ans;
}

BOOL passwordcmp(char *w)
{
	return (strcmp(initpassword,w)==0);
}

void AddReplyMark(char *content)
{
	strcpy(szBuffer,content);
	char *p;
	char *token;
	p=content;
	*p=0;
    token = strtok(szBuffer, "\n");
	while( token != NULL )
	{
		strcat(p,replyheadmark);
		strcat(p, token);
		strcat(p,"\r\n");
		token= strtok(NULL, "\n");
	}
}

