

#include <fstream.h>
#include <winsock2.h>
#include "mailheader.h"
#include "buffer.h"
#include "attachfile.h"
#include "strlist.h"


#define tACCOUNT "Account: "
#define tREFERENCES "References:"
#define tINREPLYTO "In-Reply-To:"
#define tMESSAGEID "Message-ID:"
#define tTO "To: "
#define tCC "Cc: "
#define tBCC "Bcc: "
#define tSUBJECT "Subject: "
#define remotecomtop "remote:"
#define BatTop "bat:"

#define getlinemax 1000
#define getbinarystep 100

struct mailaccount
{
	char name[MAX_INFO];
	char smtp[MAX_INFO];
	char address[MAX_INFO];
	char reply[MAX_INFO];
	char to[MAX_INFO];
	char cc[MAX_INFO];
	char bcc[MAX_INFO];
	char subject[MAX_INFO];
	char pop[MAX_INFO];
	char user[MAX_INFO];
	char password[MAX_INFO];
	char folder[MAX_PATH];
	BOOL apopmode;
	BOOL apopretry; // APOP s̏ꍇ@ǂ邩
	BOOL PopBeforeSmtp;
	BOOL SmtpAuth;
	BOOL sync;
	char SmtpAuthType[MAX_PATH];

	char passhide[MAX_INFO];//ÍpX[h

	void setname(char *n){strcpy(name,n);};
};

struct win
{
	int x;
	int y;
	int wx;
	int wy;
	int mode;
	void setmode(int i){mode=i;};
};

//mode
#define EDIT_SHOW 1
#define LIST_SHOW 2
#define BOTH_SHOW 3
#define BOTHU_SHOW 4


#define MAILGETSIZE 1024*6
#define NPOPSHOWMAX 30
#define NEXT_BLOCK "--"
#define BACK_BLOCK "++"

#define keysession "session"
#define keyfilter "filter"

_extern win mywin;
_extern long skipsize;
_extern long mailgetsize;
_extern mailaccount mymail;
_extern char starttime[30];
_extern BOOL timerflag;
_extern BOOL firsttimerflag;
_extern BOOL hidemeflag;
_extern BOOL apopmode;
_extern BOOL CopyOnReply;
_extern BOOL allrcvlog;
_extern BOOL HideSubject;
_extern BOOL rcvcopy;
_extern BOOL RemoteExeMode;
_extern BOOL shutdownflag;
_extern BOOL exeflag;
_extern BOOL commandflag;


class SendLog
{
	char *name;
	ofstream log;
	BOOL flag;
public :
	SendLog() {flag=FALSE;};
	~SendLog() {};
	void on() {flag=TRUE;};
	void off() {flag=FALSE;};
	void open(char *n) ;
	void write(char *buf);
	ofstream &getstream() {return log;};
};


_extern SendLog sendlog;
_extern BOOL sendlogonlyflag;


void init();
void saveinit();
void TranslateLine(char *buf);
mailaccount *getaccount();
void setmailaccount(char* name,char * address, char *reply,char *);
void getmailaccount(char* name,char * address, char *reply,char *);
void log(char *);
void log(char *,char*);
void rcvwrite(char *);
void initlog();
void resetlog();
void savebinary(char *,char *);
void savecontent(char *file,char *server,mailheader *mh,attach *att, char *content);
void loadcontent(char *);
void loadcontentfrommail(char *content);
void loadcontentfrommail(char *file, char *content);
BOOL loadtopfrommail(char *file, char *content,int n);
BOOL loadtopfrommailbinary(char *file, char *content,int num);
BOOL loadtopfrommail(char *file, char *content);
BOOL loadtopfromdbxmail(char *file, char *content,int num);
void loadtmpmail(char *content);
void loadtmpheader(mailheader *mh);
void sendcontent(SOCKET &,char *);
void sendcontent(SendLog &,char *);
void loadaccount();
void loadaccount(char *);
BOOL setaccount(int num);
void delfilter();
void delfiltername(char *name);
void savefilter();
void saveaccount();
void setaccountlistbox(HWND &hdlg,UINT IDC);
void setfilterlistbox(HWND &hdlg,UINT IDC);
void savesession(char *name,int num);
void savesession(char *name);
void savefiltername(char *);
void loadsession();
void loadfilter(int);
void loadfilter();
void loadfilters();
void savelist(mailheader *mh,int num);
void SetRemoteExe(mailheader *mh);
void savelist(mailheader *mh);
void SaveHeaderLog(mailheader *mh);
void ResetHeaderLog();
void SaveBoxBackUp();

void setmailsavename(mailheader *mh);
void setmailsavename(char *file);
void setmailsavename(int n);
void setmailsavename();
char* getmailsavename();
void mailsavefileinit();
void mailsave(char *);
void mailload(char *);
void ResetCurrentDir();
void settmpname(char *);
void getdateword(char *s);
char *gettmpfile(char *f);
void saveeml(char *file,char *pop);
void savesenteml(char *file);
void resetgetnum();
void getid(char *file, char *id,char *server,char *mark);
BOOL exist(strlist &li,char *key,char *,int *);
void savegetnum();
void savegetnum(int);
void getnumplus();
void getnewfilename(char *file);
int getmailline();
int gettimerminute();
void resettimerminute();
void settimerminute(int);
char* GetRemoteFrom();
char* getnowtime();
LONG GetZone();
char* GetZoneWord();
char* getnowdatetime();
char* getdateformail();
void getthismonth(char *buff,int );
void gettoday(char *buff);
void readlog(char*,int);
void setmark(int num,char *mark);
void setmark(char *uid,char *mark);
void resetmark(char *uid);
int getnumfromuid(char *uid);
void cdiropen();
void cdiropen(char* );
void saveinitcolumnsize(int n, int size);
int initcolumnsize(int n);
BOOL initpasswordcheck();
BOOL passwordcmp(char *w);
char *getdeffaoutaccount();
void SendAndLog(SOCKET s,char* buf,int len,int flags);
void skipreset();
void skipset(long);
void skipplus(long);
void skipend(char *file);
void loadnpopfile(char *f);
void setnpopfile(char *f);
void getmultifilename(int n);
void getmultifiletitle(int n,char *t);
void multifilenumplus(int n);
char *GetRemoteAppli();
char *GetCommand();
char *WriteBat();
void RemoteFileSendSet(char* file,char *content,mailheader *mh, attach *att);
char* CopyContentBat();
BOOL dbxsearch(ifstream &in,int n);
BOOL dbxboxnamesearch(char*,int n,char*);
ULONG getaddress(ifstream &in,int n);
BOOL getmultiname(char *f,int n);
void AddEmlToBox(char *file,char *box);
void AddEmlToBox(char *file,char* pop,char *box);
BOOL dustfile(char *);
void getdateforMsgId(char *s);
BOOL istmpmailfile(char *file);
void AddReplyMark(char *content);
void loadlist(mailheader *mh, int num);

void loadfilebinary(char *file,char *buf);
void sendmaildata(SOCKET &s,ifstream &in,char* str, int linelen);
void editbyeditor(char *file);

void deletealldust();

void skipdatreset();
void skipdatplus();
void skipdatplus(int n);

// backup file
void GetNextSaveFile(char *file);
int GetSaveFileNum();
void AddSaveFile(char *file);

LRESULT CALLBACK SettingProc(HWND, UINT, WPARAM, LPARAM);