
#ifndef _mailheader
#define _mailheader


#include <stdio.h>

#define MAX_SUBJECT 1024
#define MAX_SUBJECTS MAX_SUBJECT*10
#define NOSUBJECT "(no)"

#define NPOP_ADDRESSBOOK "Address.dat"

_extern char returnmark[MAX_PATH];
_extern char replyheadmark[31];

// [wb_@tB[h@f[^

struct mailheader
{
	char from[MAX_SUBJECT];
	char to[MAX_SUBJECTS];
	char cc[MAX_SUBJECTS];
	char bcc[MAX_SUBJECTS];
	char replyto[MAX_SUBJECT];
	char subject[MAX_SUBJECT];
	char messageid[MAX_SUBJECT];
	char inreplyto[MAX_SUBJECT];
	char references[MAX_SUBJECT];
	char boundary[MAX_SUBJECT];
	char linesw[MAX_SUBJECT];
	int lines;
	char date[MAX_SUBJECT];
	char dated[MAX_SUBJECT];
	char size[MAX_SUBJECT];
	char id[MAX_SUBJECT];
	char attachfile[MAX_SUBJECTS];
	char year[10];
	char month[10];
	char day[10];
	char time[10];
	char sun[10];
	char zone[10];
	char mailer[MAX_SUBJECT];
	BOOL bAttach;
	BOOL rcvend;

	char server[MAX_SUBJECT];
	char file[MAX_PATH];
	char box[MAX_PATH];
	char check[10];
	char mark[MAX_PATH];
	char rcvmark[MAX_PATH];

	void setfile(char* n) {strcpy(file,n);};
	void setsubject(char* n) {strncpy(subject,n,MAX_SUBJECT);};
	void setmark(char* n) {strcpy(mark,n);};
	void setattach(char* n) {strncpy(attachfile,n,MAX_SUBJECT);if(strlen(attachfile)>0) bAttach=TRUE;};
	void setserver(char* n) {strncpy(server,n,MAX_SUBJECT);};
	void setmailer(char* n) {strncpy(mailer,n,MAX_SUBJECT);};
	void setboxnum(int n) {sprintf(id,"%d",n);};//box numidɕۑ
	void calcdate();
	void calclines();
	void calcmonth();
	void init();
	void reset();
	void timereset();
	void setreply();
	void setsize(char* n) {strncpy(size,n,MAX_SUBJECT);};
	void setboundary(char* n) {strncpy(boundary,n,MAX_SUBJECT);};
	void AddInreplyto(char*);
	void setinreplyto(char*);
	void setmessageid(char*);
	void SetTo(char*);
	void setreferences(char*);
	void AddReferences(char*);
	void getHeaderInfo(char*);
	void getHeaderInfoLog(char*);
};


_extern mailheader mheader;


void mailheaderanalyze(char *origin,mailheader *mh);
BOOL checkmail(char *str);
BOOL dbxcheck(char *file);
void getmailaddress(char *from, char *add);
void getmailaddressname(char *data,char *address, char *name);
BOOL IsNpopAddressBook(char *file);

#endif _mailheader