
#include "defextern.h"

#ifndef STRICT
    #define STRICT
#endif
#include <windows.h>
#include <commctrl.h>
#include "initial.h"
#include "statusbar.h"

#define ID_STATUSBAR 100

int sb_size[] = {100, 200, -1};
int nStatus_h;//Xe[^Xo[̍ InternetSetStatusCallback
POINT pt;
char stbuffer[MAX_PATH];

void initstatusbar(HWND hWnd, RECT &rc)
{
	hStatus = CreateStatusWindow(WS_CHILD | WS_VISIBLE, "", hWnd, ID_STATUSBAR);
	SendMessage(hStatus, SB_SETPARTS, (WPARAM)3, (LPARAM)sb_size);
	GetWindowRect(hStatus, &rc);
	nStatus_h = rc.bottom - rc.top;
}

void setstatuscontent(char *word0)
{
	if(!statusflag) return;

	char word[100];
	memset(word,0,100);
	strncpy(word,word0,16);
	strcat(word,"...");
	strcat(word,&(word0[max(strlen(word0)-16,0)]));
	log(word);
	SendMessage(hStatus,SB_SETTEXT, (WPARAM)2 | 0, (LPARAM)(word) );
}



void setstatus(char *word)
{
	if(!statusflag) return;
	if(word==NULL) return;
	if(strlen(word)>0) log(word);
	SendMessage(hStatus,SB_SETTEXT, (WPARAM)2 | 0, (LPARAM)(word) );
}

void setstatus(char *co,char *word)
{
	if(!statusflag) return;
	if(word==NULL) return;
	if(strlen(word)>0) log(co,word);
	SendMessage(hStatus,SB_SETTEXT, (WPARAM)2 | 0, (LPARAM)(word) );
}

void settimestatus(char *word)
{
	log(word);
	wsprintf(stbuffer,"%s %s",getnowtime(),word);
	SendMessage(hStatus,SB_SETTEXT, (WPARAM)2 | 0, (LPARAM)(stbuffer) );
}


void setstatus(int num)
{
	if(!statusflag) return;
	char word[100];
	wsprintf(word,"%d",num);
	setstatus(word);
}

void setstatus(ULONG num)
{
	if(!statusflag) return;
	char word[100];
	wsprintf(word,"%d",num);
	setstatus(word);
}

void setstatus(int num,int sum)
{
	if(!statusflag) return;
	char word[100];
	wsprintf(word,"%d %d",num,sum);
	setstatus(word);
}
void setstatus(char *s,int sum)
{
	if(!statusflag) return;
	char word[100];
	wsprintf(word,"%s %d",s,sum);
	setstatus(word);
}
